/* $Id: etc.c,v 1.1 1996/11/07 08:03:32 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	Gp[`
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <ctype.h>	/* isxdigit isdigit */
#include <stdlib.h>	/* exit(), EXIT_FAILURE */
#include <stdarg.h>

#include "estruct.h"
#include "etc.h"
#include "global.h"
#include "label.h"
#include "offset.h"
#include "symbol.h"


USEOPTION	option_q;

/* function in main.c */
extern void free_load_buffer (void);
extern void print_title (void);


extern ULONG
atox (char *p)
{
    ULONG val = 0;

    if (p[0] == (char)'$')
	p++;
    /* 0x... Ȃ瓪 0x 菜 */
    else if (p[0] == (char)'0' && p[1] == (char)'x' && p[2])
	p += 2;

    while (isxdigit (*p)) {
	unsigned char c = *p++;
	val <<= 4;
	if (isdigit (c))
	    val += c - '0';
	else
	    val += tolower (c) - 'a' + 10;
    }
    return val;
}


/* tH[}bg\ăG[I. */
extern VOLATILE void
err (const char *fmt, ...)
{
    va_list ap;

    print_title();
    va_start (ap, fmt);
    vfprintf (stderr, fmt, ap);
    va_end (ap);

    free_labelbuf();
    free_relocate_buffer();
    free_symbuf();
    free_load_buffer();

    exit (EXIT_FAILURE);
}


/*

  safe malloc

*/
extern void *Malloc( ULONG byte )
{
    void	*rc;

    if( byte == 0 )
	byte = 1;
    if( ( rc = malloc( byte ) ) == NULL ) {
	err ("q[vsĂ܂\n");
    }
    return rc;
}


#ifndef	Mfree
/*

  safe mfree

  free()NULLnꍇ͉ɐÎŁA
  #define Mfree(ptr) free(ptr)
  ƂĂ܂.  

*/
extern void	Mfree( void *ptr )
{
    if( ptr != NULL )
	free( ptr );
}
#endif


/*

  safe realloc

*/
extern void	*Realloc( void *ptr , int size )
{
    void	*rc;
    
    if( ( rc = realloc( ptr , size ) ) == NULL )
	err ("q[vsĂ܂\n");
    return rc ;
}


#ifndef	__LIBC__
extern int	eprintf( const char *fmt , ... )
{
    int cnt;
    va_list ap;

    va_start (ap, fmt);
    cnt = vfprintf (stderr, fmt, ap);
    va_end (ap);
    return cnt;
}
#endif

/* #define eputc( c ) fputc( c , stderr ) */
extern int	eputc( int c )
{
    return fputc( c , stderr );
}


#ifndef	__GNUC__
extern ULONG	min( ULONG a , ULONG b )
{
    return a < b ? a : b;
}


extern ULONG	max( ULONG a , ULONG b );
{
    return a > b ? a : b;
}
#endif


/* EOF */
