/* $Id: generate.c,v 1.1 1996/11/07 08:03:36 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	\[XR[hWFl[gW[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */

#include <stdio.h>
#include <stdlib.h>	/* getenv */
#include <time.h>	/* time ctime */
#include <string.h>
#include <ctype.h>	/* tolower */
#ifdef	OSK
#include <kanji.h>	/* iskanji, etc. */
#endif	/* OSK */
#ifdef unix
    #include <jctype.h>
    #include <unistd.h>
#else
    #ifdef MYU_HEADERS
	#include <jctype.h>	/* iskanji isprkana */
    #else
	#include <jfctype.h>
    #endif
#endif
#ifdef	__LIBC__
    #include <sys/xstart.h>	/* char* _comline */
#endif

#include "disasm.h"
#include "estruct.h"
#include "etc.h"	/* charout */
#include "fpconv.h"
#include "global.h"
#include "hex.h"
#include "include.h"	/* Doscall_mac_path , etc. */
#include "label.h"	/* search_label etc. */
#include "offset.h"	/* depend_address, nearadrs */
#include "output.h"
#include "symbol.h"	/* symbol_search */
#include "table.h"
#include "generate.h"


/* Macros */
#define MIN_BIT(x) (((x) ^ ((x) - 1)) & (x))


USEOPTION option_q, option_r, option_x,
	  option_B, option_M, option_N, /* option_Q, */
	  option_S, option_U;


/* main.c */
extern mputypes	MPU_types;
extern	char	CommentChar;
extern	char	FPUID_table[16];


/* static ֐vg^Cv */
private lblbuf		*gen( char* , address , lblbuf* );
private address		textgen( address , address );
private void		labelchange (disasm *code, operand *op);
private void		a7toSP( operand * );
private void		syntax_new_to_old (operand *op);
private address		datagen( address , address , opesize );
private void		datagen_sub( address , address , opesize );

private void		dataout( address , ULONG , opesize );
private void		byteout( address , ULONG , boolean );
private void		wordout( address , ULONG );
private void		longout( address , ULONG );
private void		quadout (address pc, ULONG byte);
private void		floatout (address pc, ULONG byte);
private void		doubleout (address pc, ULONG byte);
private void		extendout (address pc, ULONG byte);
private void		packedout (address pc, ULONG byte);

private void		strgen( address , address );
private void		relgen( address , address );
private void		rellonggen( address , address );
private void		byteout_for_moption( address , char* , int );
private void		zgen( address , address );
private address		tablegen( address , address , lblmode );
private address		tablegen_sub (formula*, address, address, int);
private void		tablegen_label( address , address , lblbuf* );
private void		bssgen( address , address , opesize );
private void		label_line_out( address , lblmode );
private void		label_op_out( address );
private void		output_opecode( char* );
private char*		mputype_numstr (mputypes m);
#ifdef	__LIBC__
private void		makeheader (char*, time_t, char*, char*);
#else
private void		makeheader (char*, time_t, int, char* []);
#endif

#ifdef	OSKDIS
private void		vlabelout( address , boolean , lblmode );
#endif	OSKDIS


int	SymbolColonNum = 2;
short	sp_a7_flag;		/* a7  sp Əo͂邩? */
short	Old_syntax;

int Xtab = 7;			/* /x option TAB level */
int Atab = 8;			/* /a option TAB level */
int Mtab = 5;			/* /M option TAB level */

int Data_width = 8;		/* f[^̈̉oCg */
int String_width = 60;		/* ̈̉oCg */
int Compress_len = 64;		/* f[^o͂dcb.?ɂŏoCg */

size_mode Generate_SizeMode = SIZE_NORMAL;

char	Label_first_char = 'L';	/* x̐擪 */

char	opsize[] = "bwlqssdxp";


static mputypes	Current_Mputype;


#ifdef	OSKDIS
char	*OS9label[ 0x100 ];	/* os9	 F$???(I$???)	*/
char	*MATHlabel[ 0x100 ];	/* tcall T$Math,T$???	*/
char	*CIOlabel[ 0x100 ];	/* tcall CIO$Trap,C$??? */
#else
char	*IOCSlabel[ 0x100 ];
char	IOCSCallName[ 16 ] = "IOCS";
#endif	/* OSKDIS */


/* [ */

#ifdef	OSKDIS
#define PSEUDO	"\t"
#define EVEN	"align"
#else
#define PSEUDO	"\t."
#define EVEN	"even"
#define DCB_B	"dcb.b\t"
#define DCB_W	"dcb.w\t"
#define DCB_L	"dcb.l\t"
#define DCB_Q	"dcb.d\t"
#define DCB_S	"dcb.s\t"
#define DCB_D	"dcb.d\t"
#define DCB_X	"dcb.x\t"
#define DCB_P	"dcb.p\t"
#endif	/* !OSKDIS */

#define INCLUDE	"include\t"
#define CPU	"cpu\t"
#define FPID	"fpid\t"
#define EQU	"equ\t"
#define XDEF	"xdef\t"

#define DC_B	"dc.b\t"
#define DC_W	"dc.w\t"
#define DC_L	"dc.l\t"
#define DC_Q	"dc.d\t"
#define DC_S	"dc.s\t"
#define DC_D	"dc.d\t"
#define DC_X	"dc.x\t"
#define DC_P	"dc.p\t"

#define DS_B	"ds.b\t"
#define DS_W	"ds.w\t"
#define DS_L	"ds.l\t"

#define DEFAULT_FPID	1


/* Inline Functions */

INLINE static char  *strcpy2( char *dest , char *source )
{
    while( ( *dest++ = *source++ ) )
	;
    return --dest;
}


/*

  Check displacement of Relative branch

  return FALSE;      short    ōς displacement  word ̏ꍇ
	́Ashort||word ōς displacement  long ̏ꍇ
  return TRUE; TCYȗ\ȏꍇ.

  as.x̃oOւ̑Ή͍폜(1997/10/10).
  jmp,jsrcode.size==NOTHINGłׁA֌W(ĂяoĂQ).

*/

INLINE static boolean	check_displacement( address pc , disasm *code )
{
    long   dist = (ULONG)code->jmp - (ULONG)pc;
    char   c = code->opecode[0];

    /* bra, bsr, bcc */
    if (c == (char)'b') {
	if (code->size == WORDSIZE)
	    return ((dist <= 127) && (-dist <= 128 + 2)) ? FALSE : TRUE;
	if (code->size == LONGSIZE)
	    return ((dist <= 32767) && (-dist <= 32768 + 2)) ? FALSE : TRUE;
	return TRUE;
    }

    /* dbcc, fdbcc, pdbcc : always 16bit displacement */
    if ((c == (char)'d') || (code->opecode[1] == (char)'d')) {
	return TRUE;
    }

    /* fbcc, pbcc : 16bit or 32bit displacement */
    {
	if (code->size == LONGSIZE)
	    return ((dist <= 32767) && (-dist <= 32768 + 2)) ? FALSE : TRUE;
	return TRUE;
    }

    /* NOT REACHED */
}


/*

  AZu\[Xo͂

  input:
    xfilename	: execute file name
    sfilename	: output file name
    filedate	: execute file' time stamp
    argc	: same to argc given to main()
    argv	: same to argv given to main()

*/
extern void generate( char *xfilename , char *sfilename , time_t filedate
						, int argc , char *argv[] )
{
    address pc;
    lblbuf  *lptr;
    address nlabel;
    lblmode mode, nmode;

    /* j[jbN͕Kv */
    Disasm_String = TRUE;

    Current_Mputype = MIN_BIT (MPU_types);

    if( option_x )
	Atab += 2;

    init_output();
    output_file_open (sfilename, 0);

#if defined (__HUMAN68K__) && defined (unix)
    /* Wo͂ɏޏꍇAWG[o͂Əo͐悪ꍇ */
    /* \[XR[ho͒̕\} */
    if (is_confuse_output ()) {
	eputc ('\n');
	option_q = TRUE;
    }
#endif

#ifdef	__LIBC__
    makeheader (xfilename, filedate, argv[0], _comline);
#else
    makeheader (xfilename, filedate, argc, argv);
#endif

    lptr = next( BeginTEXT );
    pc = lptr->label;		/* ŏ */

#ifdef	OSKDIS
    lptr = gen( CR , BeginBSS , lptr );
    if( option_S ) {
	output_file_close();
	output_file_open (NULL, -1);
    }
#else
    lptr = gen( "\t.text" CR , BeginDATA , lptr );
    if( option_S ) {
	output_file_close();
	output_file_open (NULL, -1);
    }
    lptr = gen( CR "\t.data" CR , BeginBSS , lptr );
    if( option_S ) {
	output_file_close();
	output_file_open (NULL, -2);
    }
#endif	/* OSKDIS */

    nmode = lptr->mode;
    pc = lptr->label;

#ifdef	OSKDIS
    output_opecode( CR "\tvsect" CR CR );
    while( pc <= BeginDATA ) {
	mode = nmode;
	lptr = Next( lptr );
	nlabel = lptr->label;
	nmode = lptr->mode;

	if (pc == BeginDATA) break; /* D */

	vlabelout( pc , TRUE , mode );
	bssgen( pc , nlabel , mode & 0xff );
	pc = nlabel;
    }

#ifdef	DEBUG
    eprintf( "\nTEST=%08x, DATA=%08x, BSS=%08x, LAST=%08x\n",
		BeginTEXT, BeginDATA, BeginBSS, Last);
#endif	/* DEBUG */
    lptr = next( BeginDATA );	/* vsect ̏f[^̈|Cg */
    switch (HeadOSK.type & 0x0f00) {
	ULONG   *idatsiz;
	case 0x0100:		/* Program  */
	case 0x0b00:		/* Trap     */
	    {
		ULONG* idatsiz = Top - (ULONG)Head.base + (ULONG)HeadOSK.idata + 4;
		lptr = idatagen( BeginDATA + *idatsiz, lptr );
	    }			/* vsect ̏f[^o */
	    break;
	default:
	    lptr = idatagen( Last, lptr );
	    break;
    }
    pc = lptr->label;
 /* printf("pc=%08X, last=%08X\n", pc, Last ); */
    output_opecode( CR "\tends" CR );	/* end vsect */

    if (pc < Last) {
	output_opecode( CR "\tvsect\tremote" CR CR);
	while( pc <= Last ) {
	    mode = nmode;
	    lptr = Next( lptr );
	    nlabel = lptr->label;
	    nmode = lptr->mode;

	    if (pc == Last) break;	/* D */

	    vlabelout( pc , TRUE , mode );
	    bssgen( pc , nlabel , mode & 0xff );
	    pc = nlabel;
	}
	output_opecode( CR "\tends" CR );	/* end vsect remote */
    }

    output_opecode( CR "\tends" CR );	/* end psect */
    output_opecode( CR "\tend" CR );
#else
    {	/* BSS ̏o */
	boolean last_was_table = FALSE;

	output_opecode (CR "\t.bss" CR CR);

	while (pc <= Last) {
	    mode = nmode;
	    lptr = Next (lptr);
	    nlabel = lptr->label;
	    nmode = lptr->mode;

	    if (!last_was_table)
		label_line_out (pc, mode);

	    if (pc == Last)		/* D */
		break;

	    if (isTABLE (mode)) {
		pc = tablegen (pc, nlabel, mode);
		lptr = next (pc);
		nmode = lptr->mode;
		last_was_table = TRUE;
	    } else {
		bssgen (pc, nlabel, mode & 0xff);
		pc = nlabel;
		last_was_table = FALSE;
	    }
	}
    }

    output_opecode( CR "\t.end\t" );
    label_op_out( Head.exec );
#endif	/* OSKDIS */

    newline( Last );

    output_file_close();
}


/*

  PZNVo͂

  input:
    section : section name ; ".text" or ".data"
    end     : block end address
    lptr    : lblbuf* ( contains block start address )

*/
private lblbuf	*gen( char *section , address end , lblbuf *lptr )
{
    address	nlabel;
    lblmode	mode , nmode = lptr->mode;
    boolean	last_was_table = FALSE;
    address	pc = lptr->label;


    output_opecode( section );
    newline( pc );

    while( pc < end ) {
	mode = nmode;
	lptr = Next( lptr );
	while( lptr->shift ) {
	    lptr = Next( lptr );
	}
	nlabel = lptr->label;
	nmode = lptr->mode;

	if( !last_was_table )
	    label_line_out( pc , mode );

	last_was_table = FALSE;

	if( isPROLABEL( mode ) ) {
	    textgen( pc , nlabel );
	    pc = nlabel;
	} else if( isTABLE( mode ) ) {
	    pc = tablegen( pc , nlabel , mode );
	    lptr = next( pc );
	    nmode = lptr->mode;
	    last_was_table = TRUE;
	} else {
	    datagen( pc , nlabel , mode & 0xff );
	    pc = nlabel;
	}
    }
    return( lptr );
}


#ifdef	OSKDIS
/*

  f[^o͂

  input:
    end     : block end address
    lptr    : lblbuf* ( contains block start address )

*/
private lblbuf	*idatagen( address end , lblbuf *lptr )
{
    address nlabel;
    lblmode mode , nmode = lptr->mode;
    boolean last_was_table = FALSE;
    address pc = lptr->label;
    address wkpc = Top - (ULONG)Head.base + (ULONG)HeadOSK.idata + 8;

    newline( pc );

    while( pc < end ) {
	mode = nmode;
	lptr = Next( lptr );
	while( lptr->shift ) {
	    lptr = Next( lptr );
	}
	nlabel = lptr->label;
	nmode = lptr->mode;

	if( !last_was_table )
	    label_line_out( pc , mode );

	last_was_table = FALSE;

#ifdef	DEBUG
	eprintf( "PC=%08x, NEXT=%08x, MODE=%08x\n", pc, nlabel, mode);
#endif	/* DEBUG */
	wkpc = idatagen_sub(pc, wkpc, nlabel, mode);
	pc = nlabel;
    }
    return( lptr );
}
#endif	/* OSKDIS */


/*
  -MA-x IvṼ^uo
  input:
    tabnum : Mtab or Xtab
    buffer : pointer to output buffer
  return:
    pointer to end of output buffer
*/

INLINE private char *tab_out( int tabnum , char *buffer )
{
    int  i , len;

    for( len = 0 ; *buffer ; buffer++ )		/* s܂ł̒𐔂 */
	len += ( *buffer == '\t' ? 8 - len % 8 : 1 );

    /* now, buffer points buffer tail */
    for( i = tabnum - len / 8 - 1 ; i > 0 ; i-- )
	*buffer++ = '\t';

 /* *buffer = '\0'; */
    return buffer;
}


/*

  eLXgubNo͂

  input :
    pc : text begin address
    pcend : text end address

  return :
    pcend

*/
private address textgen( address pc , address pcend )
{
    address	store;
    short	made_to_order = (!sp_a7_flag || Old_syntax || option_U);
#ifdef	OSKDIS
    int		os9no;
#else
    int		iocsno;
#endif	/* OSKDIS */

    store = pc + Ofst;

    charout( '.' );
    PCEND = pcend;

    while( pc < pcend ) {
	static char	prev_fpuid = DEFAULT_FPID;
	char	buffer[ 128 ];
	char	*ptr = buffer;
	disasm	code;
	address	store0 = store;
	address	pc0 = pc;

	store += dis( store , &code , &pc );

	/* .cpu ؂芷 */
	if ((code.mputypes & Current_Mputype) == 0) {
	    Current_Mputype = MIN_BIT (code.mputypes & MPU_types);
	    output_opecode (PSEUDO CPU);
	    outputa (mputype_numstr (Current_Mputype));
	    newline (pc0);
	}

	/* .fpid ؂芷 */
	if ((code.fpuid >= 0) && (code.fpuid != prev_fpuid)) {
	    prev_fpuid = code.fpuid;
	    output_opecode (PSEUDO FPID);
	    outputfa ("%d", (int)code.fpuid);
	    newline (pc0);
	}

	if (code.flag == OTHER && code.size == code.default_size && option_N) {
	    code.size = NOTHING;
	} else if (code.flag != OTHER && code.jmpea == PCDISP) {
	    switch (Generate_SizeMode) {
		case SIZE_NORMAL:
		    if (code.size != NOTHING && check_displacement (pc, &code))
			code.size = NOTHING;
		    break;
		case SIZE_OMIT:
		    code.size = NOTHING;
		    break;
		case SIZE_NOT_OMIT:
		    break;
	    }
	}

	if (made_to_order) {
	    modify_operand (&code);
	} else {			/* "sp",,V\LȂʈ */
	    if (code.op1.operand[0]) {
		a7toSP (&code.op1);
		labelchange (&code, &code.op1);

		if (code.op2.operand[0]) {
		    a7toSP (&code.op2);
		    labelchange (&code, &code.op2);

		    if (code.op3.operand[0]) {
			a7toSP (&code.op3);
			labelchange (&code, &code.op3);

			if (code.op4.operand[0]) {
			    a7toSP (&code.op4);
			    labelchange (&code, &code.op4);
			}
		    }
		}
	    }
	}

	*ptr++ = '\t';

#ifdef	OSKDIS
	if (*(UWORD*)store0 == 0x4e40 &&	/* 0x4e40 == trap #0 (OS9)	*/
	  code.op1.opval < 0x100 &&		/* NGXgԍ $00`$FF	*/
	  OS9label[ os9no = code.op1.opval ]) {
	    strcpy(ptr, "OS9\t");
	    strcat(ptr, OS9label[ os9no ]);
	} else if (*(UWORD*)store0 == 0x4e4d &&	/* 0x4e4d == trap #13 (CIO$Trap)*/
	  code.op2.opval < 0x100 &&		/* NGXgԍ $00`$FF	*/
	  CIOlabel[ os9no = code.op2.opval ]) {
	    strcpy(ptr, "TCALL\tCIO$Trap,");
	    strcat(ptr, CIOlabel[ os9no ]);
	} else if (*(UWORD*)store0 == 0x4e4f &&	/* 0x4e40 == trap #15 (T$Math)	*/
	  code.op2.opval < 0x100 &&		/* NGXgԍ $00`$FF	*/
	  MATHlabel[ os9no = code.op2.opval ]) {
	    strcpy(ptr, "TCALL\tT$Math,");
	    strcat(ptr, MATHlabel[ os9no ]);
	}
#else
	if( code.flag == OTHER &&
	  *(UBYTE*)store0 == 0x70 &&		/* 0x70xx == moveq.l #xx,d0	*/
	  *(UWORD*)store == 0x4e4f &&		/* 0x4e4f == TRAP #15 opecode	*/
	  IOCSlabel[ iocsno = (int)*(UBYTE*)( store0 + 1 ) ] && (pc < pcend) ) {
	    ptr = strcpy2 (ptr, IOCSCallName);
	    *ptr++ = '\t';
	    strcpy2 (ptr, IOCSlabel[ iocsno ]);
	    store += 2;
	    pc += 2;
	}
#endif	/* OSKDIS */
	else {
	    ptr = strcpy2( ptr , code.opecode );
	    if( code.size < NOTHING ) {
		*ptr++ = '.';
		*ptr++ = opsize[ code.size ];
	    }

	    if( code.op1.operand[ 0 ] ) {
		*ptr++ = '\t';
		ptr = strcpy2( ptr , code.op1.operand );

		if( code.op2.operand[ 0 ] ) {
		    if( code.op2.ea != BitField && code.op2.ea != KFactor )
			*ptr++ = ',';
		    ptr = strcpy2( ptr , code.op2.operand );

		    if( code.op3.operand[ 0 ] ) {
			if( code.op3.ea != BitField && code.op3.ea != KFactor )
			    *ptr++ = ',';
			ptr = strcpy2( ptr , code.op3.operand );

			if( code.op4.operand[ 0 ] ) {
			    if( code.op4.ea != BitField && code.op4.ea != KFactor )
				*ptr++ = ',';
			    ptr = strcpy2( ptr , code.op4.operand );
			}
		    }
		}
	    }
	}

	if( code.flag == UNDEF ) {
	    char *ptr = tab_out( Mtab , buffer );	/* -MƓɏo */
	    *ptr++ = '\t';
	    *ptr++ = CommentChar;
	    strcpy( ptr , "undefined inst." );
	} else

	if( option_M ) {
	    if( code.op1.ea == IMMED ){
		switch( code.size ){
		case BYTESIZE:
		    if(
		    strnicmp( code.opecode , "cmp"  , 3 ) == 0 ||
		    ((
		    strnicmp( code.opecode , "add"  , 3 ) == 0 ||
		    strnicmp( code.opecode , "sub"  , 3 ) == 0
		    ) && (
		    code.opecode[3] != 'q' && code.opecode[3] != 'Q'
		    )) ||
		    (
		    strnicmp( code.opecode , "move" , 4 ) == 0 &&
		    code.opecode[4] != 'q' && code.opecode[4] != 'Q'
		    )
		    )
			byteout_for_moption( pc0 , buffer , BYTESIZE );
		    break;
		case WORDSIZE:
		case LONGSIZE:
		    if(
		    strnicmp( code.opecode , "cmp"  , 3 ) == 0 ||
		    (
		    strnicmp( code.opecode , "move" , 4 ) == 0 &&
		    code.opecode[4] != 'q' && code.opecode[4] != 'Q'
		    ))
			byteout_for_moption( pc0 , buffer , code.size );
		    break;
		default:
		    break;
		}
	    }
	    if( code.op3.ea == IMMED ){
		if( strnicmp( code.opecode , "pack"  , 4 ) == 0 ||
		    strnicmp( code.opecode , "unpk"  , 4 ) == 0 )
			byteout_for_moption( pc0 , buffer , NOTHING );
	    }
	}

	if( option_x )
	    byteout_for_xoption( pc0 , pc - pc0 , buffer );

	outputa( buffer );
	newline( pc0 );

	if( code.flag == RTSOP ||
	  ( code.flag == JMPOP &&
	    ( tolower( code.opecode[0] ) == 'j' ||	/* RTS ̌ɂ͋s */
	      ( option_B && !strcmpi( code.opecode , "bra" )) )
	  ) )
	    outputa( CR );
    }

    return pcend;
}



/*

	o͌`̎wɏ]ăIyhC.

	1)WX^"a7""sp"ɂ("za7""zsp"ɂ).
	2)IyR[hyъeIyh啶ɂ.
	3)xɕύXł鐔l̓xɂ.
	4)AhbVO\LÂɂ.

*/

extern void	modify_operand (disasm *code)
{
    int upper_flag = (option_U && !code->cannot_upper);

    if (upper_flag)
	strupr (code->opecode);

    if (code->op1.operand[0]) {
	if (sp_a7_flag) a7toSP (&code->op1);
	if (upper_flag) strupr (code->op1.operand);
	labelchange (code, &code->op1);
	if (Old_syntax) syntax_new_to_old (&code->op1);

	if (code->op2.operand[0]) {
	    if (sp_a7_flag) a7toSP (&code->op2);
	    if (upper_flag) strupr (code->op2.operand);
	    labelchange (code, &code->op2);
	    if (Old_syntax) syntax_new_to_old (&code->op2);

	    if (code->op3.operand[0]) {
		if (sp_a7_flag) a7toSP (&code->op3);
		if (upper_flag) strupr (code->op3.operand);
		labelchange (code, &code->op3);
		if (Old_syntax) syntax_new_to_old (&code->op3);

		if (code->op4.operand[0]) {
		    if (sp_a7_flag) a7toSP (&code->op4);
		    if (upper_flag) strupr (code->op4.operand);
		    labelchange (code, &code->op4);
		    if (Old_syntax) syntax_new_to_old (&code->op4);
		}
	    }
	}
    }
}


/*

@a7 \L sp \Lɕς

*/
private void	a7toSP( operand *op )
{
    char *ptr = op->operand;

    switch( op->ea ){
    case AregD:
	break;
    case AregID:
    case AregIDPI:
	ptr++;
	break;
    case AregIDPD:
	ptr += 2;
	break;
    case AregDISP:
	ptr = strchr( ptr , ',' ) + 1;
	break;
    case AregIDX:
	ptr = strrchr (ptr, ',') - 2;
	if (ptr[1] == (char)'7') {
	    ptr[0] = 's';
	    ptr[1] = 'p';
	}
	ptr += 3;
	break;
    case PCIDX:
	ptr = strrchr( ptr , ',' ) + 1;
	break;


    case RegPairID:
	ptr++;
	if ((ptr[0] == (char)'a') && (ptr[1] == (char)'7')) {
	    ptr[0] = 's';
	    ptr[1] = 'p';
	}
	ptr += 5;
	break;

    case PCIDXB:
    case PCPOSTIDX:
    case PCPREIDX:
    case AregIDXB:
    case AregPOSTIDX:
    case AregPREIDX:
	if (*++ptr == (char)'[') ptr++;
	while (1) {
	    if (*ptr == (char)'z') ptr++;
	    if ((ptr[0] == (char)'a') && (ptr[1] == (char)'7')) {
		*ptr++ = 's';
		*ptr++ = 'p';
	    }
	    if ((ptr = strchr (ptr, ',')) == NULL)
		break;
	    ptr++;
	}
	return;

    default:
	return;
    }

    if ((ptr[0] == (char)'a') && (ptr[1] == (char)'7')) {
	*ptr++ = 's';
	*ptr++ = 'p';
    }

}


/*

	AhbVO`̕\Lɕς.

*/

private void	syntax_new_to_old (operand *op)
{
    char *optr = op->operand;
    char *p;

    switch (op->ea) {
	case AbShort:			/* (abs)[.w] -> abs[.w] */
	case AbLong:			/* (abs)[.l] -> abs[.l] */
	    p = strchr (optr, ')');
	    strcpy (p, p + 1);
	    strcpy (optr, optr + 1);
	    break;

	case AregIDX:			/* (d8,an,ix) -> d8(an,ix) */
	    if ((optr[1] == (char)'a') || (optr[1] == (char)'A'))
		break;			/* fBXv[Xgȗ */
	    /* fall through */
	case AregDISP:			/* (d16,an)   -> d16(an)   */
	case PCIDX:			/* (d8,pc,ix) -> d8(pc,ix) */
	case PCDISP:			/* (d16,pc)   -> d16(pc)   */
	    p = strchr (optr, ',');
	    if (p == NULL)
		break;			/* Ε򖽗 */
	    *p = '(';
	    strcpy (optr, optr + 1);
	    break;

	default:
	    break;
    }
}





#ifdef	OSKDIS
/*

@f[^o͂

*/
idatagen_sub( address pc , address wkpc , address pcend , lblmode mode )
{
    ULONG byte;

    while( pc < pcend ) {
	byte = pcend - pc;
	switch (mode & 0xff) {
	    case LONGSIZE:
		if (byte != 4) goto XX;
		if (mode & CODEPTR) {
		    if (*(ULONG *)wkpc == 0) {
			outputf (PSEUDO DC_L "_btext\t* $%08x" CR, *(ULONG *)wkpc);
		    }
		    else if (*(ULONG *)wkpc == HeadOSK.name) {
			outputf (PSEUDO DC_L "_bname\t* $%08x" CR, *(ULONG *)wkpc);
		    } else {
			outputf (PSEUDO DC_L "L%06x" CR, *(ULONG *)wkpc);
			break;
		    }
		}
		else if (mode & DATAPTR) {
		    outputf (PSEUDO DC_L "L%06x" CR, BeginBSS + *(ULONG *)wkpc);
		}
		else {
		    outputf (PSEUDO DC_L "$%08x" CR, *(ULONG *)wkpc);
		}
		break;
	    case WORDSIZE:
		if (byte != 2) goto XX;
		outputf (PSEUDO DC_W "$%04x" CR, *(UWORD *)wkpc);
		break;
	    default:
XX:		byteout((ULONG)wkpc - (ULONG)Top + (ULONG)Head.base, byte, FALSE);
	}
	pc += byte;
	wkpc += byte;
    }
    return (wkpc);
}
#endif	/* OSKDIS */


/*

  f[^ubNo͂

  input :
    pc : data begin address
    pcend : data end address
    size : data size

  return :
    pcend

*/
private address datagen( address pc , address pcend , opesize size )
{
    address	next_adrs;

    while( pc < pcend ) {
	if( ( next_adrs = nearadrs( pc ) ) < pcend ) {
	    if( next_adrs != pc ) {
		datagen_sub( pc , next_adrs , size );
		pc = next_adrs;
	    }
	    output_opecode (PSEUDO DC_L);
	    label_op_out( *(address*)( next_adrs + Ofst ) );
	    newline( next_adrs );
	    pc += 4;
	} else {
	    datagen_sub( pc , pcend , size );
	    pc = pcend;
	}
    }
    return( pcend );
}


/*

  f[^ubNo͂
   : pc  pcend ܂łɂ̓AhXɈˑĂƂ͂Ȃ

  input :
    pc : data begin address
    pcend : data end address
    size : data size

*/
private void	datagen_sub( address pc , address pcend , opesize size )
{
    switch ( size ) {
    case STRING:
	strgen( pc , pcend );
	break;
    case RELTABLE:
	relgen( pc , pcend );
	break;
    case RELLONGTABLE:
	rellonggen( pc , pcend );
	break;
    case ZTABLE:
	zgen( pc , pcend );
	break;
#ifdef	OSKDIS
    case WTABLE:
	wgen( pc , pcend );
	break;
#endif	/* OSKDIS */
    default:
	dataout( pc , pcend - pc , size );
    }
}


/*

  f[^ubN̏o

  input :
    pc : data begin address
    byte : number of bytes
    size : data size ( UNKNOWN , BYTESIZE , WORDSIZE , LONGSIZE only )

*/
private void	dataout( address pc , ULONG byte , opesize size )
{
    address	store = pc + Ofst;
    int		odd_flag = (long)store & 1;

#ifdef	DEBUG
    printf( "dataout : store %x byte %x size %x\n" , store , byte , size );
#endif

    charout( '#' );
    switch (size) {

	case WORDSIZE:
	    if (odd_flag || (byte % sizeof(UWORD))) break;
	    if (byte == sizeof(UWORD)) {
		output_opecode (PSEUDO DC_W);
	     /* outputax4_without_0supress (*(UWORD*)store); */
		outputaxd (*(UWORD*)store, 4);
		newline (pc);
	    } else
		wordout (pc, byte);
	    return;

	case LONGSIZE:
	    if (odd_flag || (byte % sizeof(ULONG))) break;
	    if (byte == sizeof(ULONG)) {
		output_opecode (PSEUDO DC_L);
	     /* outputax8_without_0supress (*(ULONG*)store); */
		outputaxd (*(ULONG*)store, 8);
		newline (pc);
	    } else
		longout (pc, byte);
	    return;

	case QUADSIZE:
	    if (odd_flag || (byte % sizeof(quadword))) break;
	    quadout (pc, byte);
	    return;

	case SINGLESIZE:
	    if (odd_flag || (byte % sizeof(float))) break;
	    floatout (pc, byte);
	    return;

	case DOUBLESIZE:
	    if (odd_flag || (byte % sizeof(double))) break;
	    doubleout (pc, byte);
	    return;

	case EXTENDSIZE:
	    if (odd_flag || (byte % sizeof(long double))) break;
	    extendout (pc, byte);
	    return;

	case PACKEDSIZE:
	    if (odd_flag || (byte % sizeof(packed_decimal))) break;
	    packedout (pc, byte);
	    return;

	case BYTESIZE:
	    if (byte == sizeof(UBYTE)) {
		output_opecode (PSEUDO DC_B);
	     /* outputax2_without_0supress (*(UBYTE*)store); */
		outputaxd (*(UBYTE*)store, 2);
		newline (pc);
		return;
	    }
	    break;

	default:
	    break;
    }

    byteout (pc, byte, FALSE);
}


/*

  f[^ubN̏o

  input :
    pc : data begin address
    byte : number of bytes
    roption_flag : hex comment to string flag
    ( case this function is used for string output )

*/
private void	byteout( address pc , ULONG byte , boolean roption_flag )
{
    address	store = pc + Ofst;

#ifndef OSKDIS	/* OS-9/68K  r68 ɂ dcb ɑ^߂ */
    if (!roption_flag && (byte >= 1*2) && Compress_len && (byte >= Compress_len)) {
	int	val = *(UBYTE*)store;
	address	ptr = store;

	while( ptr < store + byte && *(UBYTE*)ptr == val )
	    ptr++;
	if( ptr == store + byte ) {
	    if( val == 0 ) {
		output_opecode (PSEUDO DS_B);
		outputfa( "%d" , byte );
	    } else {
		output_opecode (PSEUDO DCB_B);
		outputfa( "%d," , byte );
		outputax2_without_0supress( val );
	    }
	    newline( pc );
	    return;
	}
    }
#endif	/* !OSKDIS */

    {
	ULONG	max = ( byte - 1 ) / Data_width;
	ULONG	mod = ( byte - 1 ) % Data_width;
	int	i , j;

	for( i = 0 ; i <= max ; i++ ) {
	    if (roption_flag) {
		static char comment[] = ";\t\t";
		comment[0] = CommentChar;
		outputa (comment);
	    } else
		output_opecode (PSEUDO DC_B);

	    for( j = 1 ; j < ( i == max ? mod + 1 : Data_width ) ; j++ ) {
		outputax2_without_0supress( *(UBYTE*)store++ );
		outputca( ',' );
	    }
	    outputax2_without_0supress( *(UBYTE*)store++ );
	    newline( pc );
	    pc += Data_width;
	}
    }
}


private void	wordout( address pc , ULONG byte )
{
    address	store = pc + Ofst;

#ifndef OSKDIS
    if ((byte >= 2*2) && Compress_len && (byte >= Compress_len)) {
	int	val = *(UWORD*)store;
	address	ptr = store;

	while( ptr < store + byte && *(UWORD*)ptr == val )
	    ptr += 2;
	if( ptr == store + byte ) {
	    if( val == 0 ) {
		output_opecode (PSEUDO DS_W);
		outputfa( "%d" , byte / 2 );
	    } else {
		output_opecode (PSEUDO DCB_W);
		outputfa( "%d," , byte / 2 );
		outputax4_without_0supress( val );
	    }
	    newline( pc );
	    return;
	}
    }
#endif	/* !OSKDIS */

    {
	int	datawidth = ( Data_width + 1 ) / 2;
	ULONG	max = ( byte/2 - 1 ) / datawidth;
	ULONG	mod = ( byte/2 - 1 ) % datawidth;
	int	i , j;

	for( i = 0 ; i <= max ; i++ ) {
	    output_opecode (PSEUDO DC_W);
	    for( j = 1 ; j < ( i == max ? mod + 1 : datawidth ) ; j++ ) {
		outputax4_without_0supress( *(UWORD*)store );
		store += 2;
		outputca( ',' );
	    }
	    outputax4_without_0supress( *(UWORD*)store );
	    store += 2;
	    newline( pc );
	    pc += datawidth*2;
	}
    }
}


private void	longout( address pc , ULONG byte )
{
    address	store = pc + Ofst;

#ifndef OSKDIS
    if ((byte >= 4*2) && Compress_len && (byte >= Compress_len)) {
	int	val = *(ULONG*)store;
	address	ptr = store;

	while( ptr < store + byte && *(ULONG*)ptr == val )
	    ptr += 4;
	if( ptr == store + byte ) {
	    if( val == 0 ) {
		output_opecode (PSEUDO DS_L);
		outputfa( "%d" , byte / 4 );
	    } else {
		output_opecode (PSEUDO DCB_L);
		outputfa( "%d," , byte / 4 );
		outputax8_without_0supress( val );
	    }
	    newline( pc );
	    return;
	}
    }
#endif	/* !OSKDIS */

    {
	int	datawidth = ( Data_width + 3 ) / 4;
	ULONG	max = ( byte/4 - 1 ) / datawidth;
	ULONG	mod = ( byte/4 - 1 ) % datawidth;
	int	i , j;

	for( i = 0 ; i <= max ; i++ ) {
	    output_opecode (PSEUDO DC_L);
	    for( j = 1 ; j < ( i == max ? mod + 1 : datawidth ) ; j++ ) {
		outputax8_without_0supress( *(ULONG*)store );
		store += 4;
		outputca( ',' );
	    }
	    outputax8_without_0supress( *(ULONG*)store );
	    store += 4;
	    newline( pc );
	    pc += datawidth*4;
	}
    }
}


private void	quadout (address pc, ULONG byte)
{
    quadword* store = (quadword*)(pc + Ofst);
    char buf[64];
    int i = (byte / sizeof(quadword));

#ifndef OSKDIS
    if ((i >= 2) && Compress_len && (byte >= Compress_len)
		 && (memcmp (store, store + 1, byte - sizeof(quadword)) == 0)) {
	fpconv_q (buf, store);
	output_opecode (PSEUDO DCB_Q);
	outputfa ("%d,%s", i, buf);
	newline (pc);
	return;
    }
#endif

    do {
	fpconv_q (buf, store++);
	output_opecode (PSEUDO DC_Q);
	outputa (buf);
	newline (pc);
	pc += sizeof(quadword);
    } while (--i);
}


private void	floatout (address pc, ULONG byte)
{
    float* store = (float*)(pc + Ofst);
    char buf[64];
    int i = (byte / sizeof(float));

#ifndef OSKDIS
    if ((i >= 2) && Compress_len && (byte >= Compress_len)
		 && (memcmp (store, store + 1, byte - sizeof(float)) == 0)) {
	fpconv_s (buf, store);
	output_opecode (PSEUDO DCB_S);
	outputfa ("%d,%s", i, buf);
	newline (pc);
	return;
    }
#endif

    do {
	fpconv_s (buf, store++);
	output_opecode (PSEUDO DC_S);
	outputa (buf);
	newline (pc);
	pc += sizeof(float);
    } while (--i);
}


private void	doubleout (address pc, ULONG byte)
{
    double* store = (double*)(pc + Ofst);
    char buf[64];
    int i = (byte / sizeof(double));

#ifndef OSKDIS
    if ((i >= 2) && Compress_len && (byte >= Compress_len)
		 && (memcmp (store, store + 1, byte - sizeof(double)) == 0)) {
	fpconv_d (buf, store);
	output_opecode (PSEUDO DCB_D);
	outputfa ("%d,%s", i, buf);
	newline (pc);
	return;
    }
#endif

    do {
	fpconv_d (buf, store++);
	output_opecode (PSEUDO DC_D);
	outputa (buf);
	newline (pc);
	pc += sizeof(double);
    } while (--i);
}


private void	extendout (address pc, ULONG byte)
{
    long double* store = (long double*)(pc + Ofst);
    char buf[64];
    int i = (byte / sizeof(long double));

#ifndef OSKDIS
    if ((i >= 2) && Compress_len && (byte >= Compress_len)
		 && (memcmp (store, store + 1, byte - sizeof(long double)) == 0)) {
	fpconv_x (buf, store);
	output_opecode (PSEUDO DCB_X);
	outputfa ("%d,%s", i, buf);
	newline (pc);
	return;
    }
#endif

    do {
	fpconv_x (buf, store++);
	output_opecode (PSEUDO DC_X);
	outputa (buf);
	newline (pc);
	pc += sizeof(long double);
    } while (--i);
}


private void	packedout (address pc, ULONG byte)
{
    packed_decimal* store = (packed_decimal*)(pc + Ofst);
    char buf[64];
    int i = (byte / sizeof(packed_decimal));

#ifndef OSKDIS
    if ((i >= 2) && (memcmp (store, store + 1, byte - sizeof(packed_decimal)) == 0)) {
	fpconv_p (buf, store);
	output_opecode (PSEUDO DCB_P);
	outputfa ("%d,%s", i, buf);
	newline (pc);
	return;
    }
#endif

    do {
	fpconv_p (buf, store++);
	output_opecode (PSEUDO DC_P);
	outputa (buf);
	newline (pc);
	pc += sizeof(packed_decimal);
    } while (--i);
}





/*

  -M IvṼRg

  input :
    pc : address of 'cmpi.?, move.b, addi.b, subi.? #??' instruction
    buffer : pointer to output buffer

*/
private void	byteout_for_moption( address pc , char *buffer , int size )
{
    int		l = 0;
    char	*ptr;
    address	store = pc + Ofst;

    switch( size ){
    case BYTESIZE:
	if( !isprint( *(unsigned char*)( store + 3 ) ) )
	    return;
	break;
    case WORDSIZE:
	if(
	!(isprint( *(unsigned char*)( store + 2 ) ) || *(unsigned char*)( store + 2 ) == 0 ) ||
	! isprint( *(unsigned char*)( store + 3 ) )
	)
	    return;
	break;
    case LONGSIZE:
	if(
	!(isprint( *(unsigned char*)( store + 2 ) ) || *(unsigned char*)( store + 2 ) == 0 ) ||
	! isprint( *(unsigned char*)( store + 3 ) ) ||
	! isprint( *(unsigned char*)( store + 4 ) ) ||
	!(isprint( *(unsigned char*)( store + 5 ) ) || *(unsigned char*)( store + 5 ) == 0 )
	)
	    return;
	break;
    default:	/* pack,unpk ̏ꍇɗ */
	if(!( isprint( *(unsigned char*)( store + 2 )) || *(unsigned char*)( store + 2 )==0 ))	return;
	if(!( isprint( *(unsigned char*)( store + 3 )) || *(unsigned char*)( store + 3 )==0 ))	return;
	l  = ( *(unsigned char*)( store + 2 ) ) ? 1 : 0;
	l += ( *(unsigned char*)( store + 3 ) ) ? 2 : 0;
	if( l == 0 )	return;
	break;
    }


    ptr = tab_out( Mtab , buffer );
    *ptr++ = '\t';
    *ptr++ = CommentChar;	/* at least one TAB */
    *ptr++ = '\'';

    switch( size ){
    case BYTESIZE:
	*ptr++ = *(unsigned char*)( store + 3 );
	break;
    case WORDSIZE:
	if( *(unsigned char*)( store + 2 ) ){
	    *ptr++ = *(unsigned char*)( store + 2 );
	}
	*ptr++ = *(unsigned char*)( store + 3 );
	break;
    case LONGSIZE:
	if( *(unsigned char*)( store + 2 ) ){
	    *ptr++ = *(unsigned char*)( store + 2 );
	}
	*ptr++ = *(unsigned char*)( store + 3 );
	*ptr++ = *(unsigned char*)( store + 4 );
	if( *(unsigned char*)( store + 5 ) )
	    *ptr++ = *(unsigned char*)( store + 5 );
	else{
	    strcpy( ptr, "\'*256" );
	    return;
	}
	break;
    default:	    /* pack,unpk̏ꍇ */
	switch( l ){
	case 1:
	    *ptr++ = *(unsigned char*)( store + 2 );
	    strcpy( ptr, "\'*256" );
	    return;
	case 2:
	    *ptr++ = *(unsigned char*)( store + 3 );
	    break;
	case 3:
	    *ptr++ = *(unsigned char*)( store + 2 );
	    *ptr++ = *(unsigned char*)( store + 3 );
	    break;
	}
    }

    *ptr++ = '\'';
    *ptr++ = '\0';
}



/*

  -x IvṼRg

  input :
    pc : address of instruction
    byte : instruction length in byte
    buffer : pointer to output buffer

*/
extern void	byteout_for_xoption( address pc , ULONG byte , char *buffer )
{
    int		i;
    char	*ptr;
    address	store = pc + Ofst;

    ptr = tab_out( Xtab , buffer );
    *ptr++ = '\t';
    *ptr++ = CommentChar;	/* at least one TAB */

    for( i = 0 ; i < byte - 2 ; i += 2 , store += 2 ) {
	*ptr++ = '$';
	ptr = itox4_without_0supress( ptr , *(UWORD*)store );
	*ptr++ = ',';
    }
    *ptr++ = '$';
    itox4_without_0supress( ptr , *(UWORD*)store );
}


/*

  ̏o

  input :
    pc : string begin address
    pcend : string end address

*/
#ifdef	OSKDIS
#define QUOTE_CHAR	'\"'
#define QUOTE_STR	"\""
#else
#define QUOTE_CHAR	'\''
#define QUOTE_STR	"\'"
#endif	/* OSKDIS */

#define ENTERSTR() \
    if (!strmode) {						\
	if (comma) { outputa ("," QUOTE_STR); column += 2; }	\
	else { outputca (QUOTE_CHAR); column++;}		\
	strmode = TRUE;						\
    }
#define EXITSTR() \
    if (strmode) {		\
	outputca (QUOTE_CHAR);	\
	column++;		\
	strmode = FALSE;	\
    }

static INLINE boolean
is_sb (unsigned char* ptr)
{
    return (isprkana (ptr[0]) && ptr[0] != QUOTE_CHAR);
}

static INLINE boolean
is_mb_zen (unsigned char* ptr)
{
    return (iskanji (ptr[0]) && iskanji2 (ptr[1]));
}

static INLINE boolean
is_mb_han (unsigned char* ptr)
{
    if (ptr[0] == 0x80 || (0xf0 <= ptr[0] && ptr[0] <= 0xf3)) {
	if ((0x20 <= ptr[1] && ptr[1] <= 0x7e)
	 || (0x86 <= ptr[1] && ptr[1] <= 0xfd))
	    return TRUE;
    }
    return FALSE;
}

private void
strgen (address pc, address pcend)
{
    address	store = Ofst + pc;
    address	stend = Ofst + pcend;

    charout ('s');

    while (store < stend) {
	address    store0 = store;
	boolean    strmode = FALSE;
	int	column = 0;
	char	comma = 0;		/* 1 Ȃ , o͂ */

	output_opecode (PSEUDO DC_B);

	while (column < String_width && store < stend) {

	    if (is_sb (store)) {
		/* ANK  */
		ENTERSTR();
		outputca (*(UBYTE*)store++);
		column++;
	    } else if (is_mb_zen (store) && store + 1 < stend) {
		/* oCgSp */
		ENTERSTR();
		outputca (*(UBYTE*)store++);
		outputca (*(UBYTE*)store++);
		column += 2;
	    } else if (is_mb_han (store) && store + 1 < stend) {
		/* oCgp */
		ENTERSTR();
		outputca (*(UBYTE*)store++);
		outputca (*(UBYTE*)store++);
		column++;
	    } else {
		unsigned char c = *(UBYTE*)store++;
		EXITSTR();
		if (comma)
		    outputca (',');
		outputax2_without_0supress (c);
		column += comma + 3;				/* ,$xx */

		/* \n ܂ NUL Ȃs */
		if (store != stend && (c == '\n' || c == '\0')) {
		    /* Aɑ NUL ͑SĈsɔ[߂ */
		    if (*(UBYTE*)store == '\0')
			;
		    else
			break;					/* s */
		}
	    }
	    comma = 1;
	}
	if (strmode)
	    outputca (QUOTE_CHAR);

	newline (store0 - Ofst);
	if (option_r)
	    byteout (store0 - Ofst, store - store0, TRUE);
    }
}
#undef	ENTERSTR
#undef	EXITSTR
#undef	QUOTE_CHAR


/*

  eBuItZbge[ȕo

  input :
    pc : relative offset table begin address
    pcend : relative offset table end address

*/
private void	relgen( address pc , address pcend )
{
    char	work0[ 128 ] , work1[ 128 ];
    char	*temp;
    address	store = pc + Ofst;
    int		dif;

    charout( 'r' );

    make_proper_symbol( work0 , pc );

    while( store - Ofst < pcend ) {
	dif = (int)*(signed short*)store;
	store += 2;
	if( (LONG)( pc + dif ) < (LONG)BeginTEXT ) {
	    make_proper_symbol( work1 , BeginTEXT );
	    temp = strend( work1 );
	    *temp++ = '-';
	    itox6d( temp , BeginTEXT - ( pc + dif ) );
	} else if( (LONG)( pc + dif ) > (LONG)Last ) {
	    make_proper_symbol( work1 , Last );
	    temp = strend( work1 );
	    *temp++ = '+';
	    itox6d( temp , ( pc + dif ) - Last );
	} else
	    make_proper_symbol( work1 , pc + dif );

	output_opecode (PSEUDO DC_W);
	outputfa( "%s-%s" , work1 , work0 );
	newline( store - 2 - Ofst );
    }
}


/*

  O[hȃeBuItZbge[ȕo

  input :
    pc : relative offset table begin address
    pcend : relative offset table end address

*/
private void	rellonggen( address pc , address pcend )
{
    char	work0[ 128 ] , work1[ 128 ];
    char	*temp;
    address	store = pc + Ofst;
    int		dif;

    charout( 'R' );

    make_proper_symbol( work0 , pc );

    while( store - Ofst < pcend ) {
	dif = (int)*(signed long*)store;
	store += 4;
	if( (LONG)( pc + dif ) < (LONG)BeginTEXT ) {
	    make_proper_symbol( work1 , BeginTEXT );
	    temp = strend( work1 );
	    *temp++ = '-';
	    itox6d( temp , BeginTEXT - ( pc + dif ) );
	} else if( (LONG)( pc + dif ) > (LONG)Last ) {
	    make_proper_symbol( work1 , Last );
	    temp = strend( work1 );
	    *temp++ = '+';
	    itox6d( temp , ( pc + dif ) - Last );
	} else
	    make_proper_symbol( work1 , pc + dif );

	output_opecode (PSEUDO DC_L);
	outputfa( "%s-%s" , work1 , work0 );
	newline( store - 4 - Ofst );
    }
}


#ifdef	OSKDIS
/*

  [he[ȕo

  input:
    pc : word table begin address
    pcend : word table end address

*/
private void	wgen( address pc , address pcend )
{
    char    work[ 128 ];
    char    *temp;
    address store;
    address label;

    charout( 'w' );

    for( store = pc + Ofst ; store + 2 <= pcend + Ofst ; store += 2 ) {
	label = (int)*(signed short*)store;
	if( (LONG)label < (LONG)BeginTEXT ) {
	    make_proper_symbol( work , BeginTEXT );
	    temp = strend( work );
	    *temp++ = '-';
	    itox6d( temp , (ULONG)( BeginTEXT - label ) );
	} else if( (LONG)label > (LONG)Last ) {
	    make_proper_symbol( work , Last );
	    temp = strend( work );
	    *temp++ = '+';
	    itox6d( temp , (ULONG)( label - Last ) );
	} else {
	    make_proper_symbol( work ,  label );
	}
	output_opecode (PSEUDO DC_W);
	outputa( work );
	newline( store - Ofst );
    }
    if( store != pcend + Ofst )
	dataout( store  - Ofst , pcend + Ofst - store , UNKNOWN );
}
#endif	/* OSKDIS */

/*

  O[he[ȕo

  input :
    pc : longword table begin address
    pcend : longword table end address

*/
private void	zgen( address pc , address pcend )
{
    char	work[ 128 ];
    char	*temp;
    address	store;
    address	label;

    charout( 'z' );

    for( store = pc + Ofst ; store + 4 <= pcend + Ofst ; store += 4 ) {
	label = *(address*)store;
	if( (LONG)label < (LONG)BeginTEXT ) {
	    make_proper_symbol( work , BeginTEXT );
	    temp = strend( work );
	    *temp++ = '-';
	    itox6d( temp , (ULONG)( BeginTEXT - label ) );
	} else if( (LONG)label > (LONG)Last ) {
	    make_proper_symbol( work , Last );
	    temp = strend( work );
	    *temp++ = '+';
	    itox6d( temp , (ULONG)( label - Last ) );
	} else {
	    make_proper_symbol( work , label );
	}
	output_opecode (PSEUDO DC_L);
	outputa( work );
	newline( store - Ofst );
    }
    if( store != pcend + Ofst )
	dataout( store - Ofst , pcend + Ofst - store , UNKNOWN );
}


/*

  [U[`̃e[ȕo

  input :
    pc : user defined table begin address
    pcend : user defined table end address( not used )
    mode : table attribute( not used )
  return :
    table end address

*/
static boolean	end_by_break;

private address tablegen( address pc , address pcend , lblmode mode )
{
    int		loop , i;
    table	*tableptr;

#ifdef	DEBUG
    eprintf ("enter tablegen\n");
#endif

    charout( 't' );
    if( ( tableptr = search_table( pc ) ) == NULL ) {
	err ("Table  %06x (!?)\n" , pc);
    }

    end_by_break = FALSE;
    pc = tableptr->tabletop;

    for( loop = 0 ; loop < tableptr->loop ; loop++ ) {	/* implicit loop */
	for( i = 0 ; i < tableptr->lines ; i++ ) {	/* line# loop */
#ifdef	DEBUG
	    eprintf ("loop=%d i=%d\n", loop, i);
#endif
	    pc = tablegen_sub( &( tableptr->formulaptr[ i ] ) ,
			       tableptr->tabletop , pc , i + 1 < tableptr->lines );
	 /* if( ( lptr = search_label( Eval_PC ) ) != NULL ) {
#ifdef	DEBUG
		eprintf ("THERE IS LABEL (%x)\n", Eval_PC);
#endif
		label_line_out( Eval_PC , FALSE );
	    } */
	    if( end_by_break ) {
		goto ret;
	    }
	}
    }

 ret:
#ifdef	DEBUG
    eprintf ("exit tablegen\n");
#endif
    return pc;
}


/*

  [U`̃e[ȕo

  input :
    exprptr : [U`̃e[uPs̍\
    tabletop : table top address
    pc : pointing address
    notlast : true iff this line is not last line at table
  return :
    next pointing address

*/
static void	tablegen_dc (address, lblbuf*, char*, int);

private address tablegen_sub( formula *exprptr
				, address tabletop , address pc , int notlast )
{

    ParseMode = PARSE_GENERATING;
    Eval_TableTop = tabletop;
    Eval_Count = 0;
    Eval_PC = pc;

    do {
	extern int	yyparse (void);

	lblbuf*	lptr = next (Eval_PC + 1);
	address	nextlabel = lptr->label;
	int	str_length;
	boolean	pc_inc_inst;

	Eval_ResultString[0] = '\0';
	Lexptr = exprptr->expr;

#ifdef	DEBUG
	eprintf ("parsing %s\n", Lexptr);
#endif
	yyparse();

	/* CRID, BREAKID, EVENID(.even o͎)ȊO͑S TRUE */
	pc_inc_inst = TRUE;

	switch( exprptr->id ) {
	case LONGSIZE:
	    tablegen_dc (nextlabel, lptr, PSEUDO DC_L, 4);
	    break;
	case WORDSIZE:
	    tablegen_dc (nextlabel, lptr, PSEUDO DC_W, 2);
	    break;
	case BYTESIZE:
	    output_opecode (PSEUDO DC_B);
	    outputa( Eval_ResultString );
	    newline( Eval_PC );
	    Eval_PC++;
	    break;

	case SINGLESIZE:
	    tablegen_dc (nextlabel, lptr, PSEUDO DC_S, 4);
	    break;
	case DOUBLESIZE:
	    tablegen_dc (nextlabel, lptr, PSEUDO DC_D, 8);
	    break;
	case EXTENDSIZE:
	    tablegen_dc (nextlabel, lptr, PSEUDO DC_X, 12);
	    break;
	case PACKEDSIZE:
	    tablegen_dc (nextlabel, lptr, PSEUDO DC_P, 12);
	    break;

#if 0
	case LONGID:
	    if( nextlabel < Eval_PC + Eval_Bytes*4 )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes*4 , lptr );
	    else
		datagen( Eval_PC , Eval_PC + Eval_Bytes*4 , LONGSIZE );
	    Eval_PC += Eval_Bytes*4;
	    break;

	case WORDID:
	    if( nextlabel < Eval_PC + Eval_Bytes*2 )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes*2 , lptr );
	    else
		datagen( Eval_PC , Eval_PC + Eval_Bytes*2 , WORDSIZE );
	    Eval_PC += Eval_Bytes*2;
	    break;
#endif
	case BYTEID:
	    if( nextlabel < Eval_PC + Eval_Bytes )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes , lptr );
	    else
		datagen( Eval_PC , Eval_PC + Eval_Bytes , BYTESIZE );
	    Eval_PC += Eval_Bytes;
	    break;
	case ASCIIID:
	    if( nextlabel < Eval_PC + Eval_Bytes )
		tablegen_label( Eval_PC , Eval_PC + Eval_Bytes , lptr );
	    else
		strgen( Eval_PC , Eval_PC + Eval_Bytes );
	    Eval_PC += Eval_Bytes;
	    break;
	case ASCIIZID:
	    str_length = strlen( (char*)Eval_PC + Ofst ) + 1;
	    if( nextlabel < Eval_PC + str_length )
		tablegen_label( Eval_PC , Eval_PC + str_length , lptr );
	    else
		strgen( Eval_PC , Eval_PC + str_length );
	    Eval_PC += str_length;
	    break;
	case LASCIIID:
	    str_length = *(unsigned char*)( Eval_PC + Ofst );
	    datagen( Eval_PC , Eval_PC + 1 , BYTESIZE );
	    Eval_PC++;
	    if( nextlabel < Eval_PC + str_length )
		tablegen_label( Eval_PC , Eval_PC + str_length , lptr );
	    else
		strgen( Eval_PC , Eval_PC + str_length );
	    Eval_PC += str_length;
	    break;
	case EVENID:
	    output_opecode (PSEUDO EVEN);
	    newline( Eval_PC );
	    if ((int)Eval_PC & 1)
		Eval_PC++;	/* pc_inc_inst = TRUE; */
	    else
		pc_inc_inst = FALSE;
	    break;
	case CRID:
	    newline( Eval_PC );
	    pc_inc_inst = FALSE;
	    break;
	case BREAKID:
	    if( Eval_Break ) {
#ifdef	DEBUG
		eprintf ("END_BY_BREAK!(%x)\n", (unsigned int)Eval_PC);
#endif
		end_by_break = TRUE;
		goto tableend;
	    }
	    pc_inc_inst = FALSE;
	    break;
	default:	/* reduce warning message */
	    break;
	}
	if( ( lptr = search_label( Eval_PC ) ) != NULL ) {
#ifdef	DEBUG
	    eprintf ("THERE IS LABEL sub (%x)%x\n", (unsigned int)Eval_PC, lptr->mode);
#endif
#if 0	/* does not work properly */
	    if( isTABLE( lptr->mode ) && notlast ) {
		eprintf ("\nEncounter another table in table(%x).\n" , Eval_PC);
	    }
#endif
	    if( isENDTABLE( lptr->mode ) ) {
		/* if .even here.... */
		if( notlast && (exprptr+1)->id == EVENID ) {
		    output_opecode (PSEUDO EVEN);
		    newline( Eval_PC );
		    Eval_PC += ( (int)Eval_PC & 1 );
		}
		label_line_out( Eval_PC , FALSE );
#ifdef	DEBUG
		eprintf ("ENCOUNTER ENDTABLE(%x)", (unsigned int)Eval_PC);
#endif
		end_by_break = TRUE;
		goto tableend;
	    } else if( pc_inc_inst )
		/* labelout is not required at end of table */
		label_line_out( Eval_PC , FALSE );
	}
    } while( --Eval_Count > 0 );
 tableend:
#ifdef	DEBUG
    eprintf ("exit tablegen_sub()\n");
#endif
    return Eval_PC;
}

static void
tablegen_dc (address nextlabel, lblbuf* lptr, char* op, int size)
{
    if (nextlabel < Eval_PC + size)
	tablegen_label (Eval_PC, Eval_PC + size, lptr);
    else {
	output_opecode (op);
	outputa (Eval_ResultString);
	newline (Eval_PC);
    }
    Eval_PC += size;
}


/*

  e[uɃx݂ꍇ̃f[^ubNo

  input :
    pc : point address
    pcend : point address' end address
    lptr : e[ũx

*/
private void	tablegen_label( address pc , address pcend , lblbuf *lptr )
{
    address	nlabel = lptr->label;
    lblmode	mode , nmode = lptr->mode;

#ifdef	DEBUG
    eprintf ("tablegen_label(%x,%x,%x)\n",
		(unsigned int)pc, (unsigned int)pcend, (unsigned int)nlabel);
#endif
    pc = datagen( pc , nlabel , nmode & 0xff );
    while( pc < pcend ) {
	mode = nmode;
	lptr = next( pc + 1 );
	while( lptr->shift )
	    lptr = Next( lptr );

	nlabel = lptr->label;
	nmode = lptr->mode;

	label_line_out( pc , mode );
	if( isPROLABEL( mode ) )
	    pc = textgen( pc , min( nlabel , pcend ) );
	else
	    pc = datagen( pc , min( nlabel , pcend ) , mode & 0xff );
    }
#ifdef	DEBUG
    eprintf ("exit tablegen_label\n");
#endif
}


/*

  bss ̈̏o

  input :
    pc : data begin address
    pcend : data end address
    size : data size

*/
private void	bssgen( address pc , address nlabel , opesize size )
{
    ULONG	byte;

    charout( '$' );
    nlabel = (address)min( (ULONG)nlabel , (ULONG)Last );
    byte = nlabel - pc;

    if( (LONG)nlabel >= 0 ) {
	if( byte == 0 )
	    newline( pc );
	else {
	    switch ( size ) {
	    case WORDSIZE:
		if( byte != 2 ) goto out;
		output_opecode (PSEUDO DS_W "1");
		newline( pc );
		break;
	    case LONGSIZE:
		if( byte != 4 ) goto out;
		output_opecode (PSEUDO DS_L "1");
		newline( pc );
		break;
	    case BYTESIZE:
	    case UNKNOWN:
	    default:
	    out:
		output_opecode (PSEUDO DS_B);
		outputfa( "%d" , byte );
		newline( pc );
	    }
	}
    }
}


/*

  x̕tւ

  input :
    code : disassembled opecode
    operand : operand ( op1,op2,op3 or op4 )

  return :
    TRUE if output is 'label[+-]??' style ( used to avoid as.x bug )
    ()as.xɂ͑ΉȂȂׁAԒl͍폜.

	Ablong		PCDISP		IMMED	    PCIDX
    0	(label)		(label,pc)	#label	    (label,pc,ix)
    1	(label-$num)	(label-$num,pc)	#label-$num (label-$num,pc,ix)
    2	(label+$num)	(label+$num,pc)	#label+$num (label+$num,pc,ix)

(od̓AhXˑexod4̎label)
	PCIDXB		    PCPOSTIDX		    PCPREIDX
	(label,pc,ix)	    ([label,pc],ix,label)   ([label,pc,ix],label)

(bd,od̓AhXˑexbd,exodꂼ4̎label)
	AregIDXB	    AregPOSTIDX		    AregPREIDX
	(label,an,ix)	    ([label,an],ix,label)   ([label,an,ix],label)

*/
private void	labelchange( disasm *code , operand *op )
{
    address arg1;
    LONG    shift;

    if( op->opval != (address)-1 &&
      ( op->labelchange1 ||
	( ( op->ea == AbLong || ((op->ea == IMMED) && (code->size2 == LONGSIZE)) )
	&& INPROG( op->opval , op->eaadrs ) )
      )
    ) {
	char	buff[64];
	char	*base = buff;
	char	*ext_operand = NULL;

	switch( op->ea ){
	default:
	case IMMED:
	    break;
	case AbLong:
	/*  ext_operand = strchr( op->operand , ')' );  */
	    ext_operand = ")";
	    break;

	case AregPOSTIDX:
	case AregPREIDX:
	    if (!INPROG (op->opval, op->eaadrs))
		goto bd_skip;
	    ext_operand = strpbrk (op->operand, "],");
	    break;

	case PCDISP:
	    if( (char)op->labelchange1 < 0 )
		break;		/* bsr label ͊ʂȂ */
	    /* fall through */
	case AregIDXB:
	case PCIDX:
	    ext_operand = strchr( op->operand , ',' );
	    break;
	case PCIDXB:
	    ext_operand = strchr( op->operand , ',' );
	    goto check_size;
	case PCPOSTIDX:
	case PCPREIDX:
	    ext_operand = strpbrk (op->operand, "],");
check_size: if (ext_operand[-2] == (char)'.')
		ext_operand -= 2;	/* TCYtȂt */
	    break;
	}

	if( (LONG)op->opval < (LONG)BeginTEXT ) {
	    arg1 = BeginTEXT;
	    shift = (LONG)op->opval - (LONG)BeginTEXT;
	} else if( (ULONG)op->opval > (ULONG)Last ) {
	    arg1 = Last;
	    shift = (ULONG)op->opval - (ULONG)Last;
	} else {
	    lblbuf  *label_ptr;

	    if( ( label_ptr = search_label( op->opval ) ) == NULL )
		/*  opval ÕxT */
		/* }shift `ɂׂ??		 */
		return;
	    else {
		shift = label_ptr->shift;
		arg1 = op->opval - shift;
	    }
	}

	switch( op->ea ){
	default:
	    break;
	case IMMED:
	    *base++ = '#';
	    break;
	case PCDISP:
	    if( (char)op->labelchange1 < 0 )
		break;		/* bsr label ͊ʂȂ */
	    /* fall through */
	case AbLong:
	case PCIDX:
	case AregIDXB:
	case PCIDXB:
	    *base++ = '(';
	    break;
	case AregPOSTIDX:
	case AregPREIDX:
	case PCPOSTIDX:
	case PCPREIDX:
	    *base++ = '(';
	    *base++ = '[';
	    break;
	}

	base = make_symbol( base , arg1 , shift );

	if (ext_operand)
	    strcpy( base , ext_operand );

	strcpy( op->operand , buff );
    }

bd_skip:


/* AE^fBXv[Xgp */
    if( op->labelchange2 && op->opval2 != (address)-1 &&
	INPROG( op->opval2, op->eaadrs2)
    ) {
	char *ptr;

	if( (LONG)op->opval2 < (LONG)BeginTEXT ) {
	    arg1 = BeginTEXT;
	    shift = (LONG)op->opval2 - (LONG)BeginTEXT;
	} else if( (ULONG)op->opval2 > (ULONG)Last ) {
	    arg1 = Last;
	    shift = (ULONG)op->opval2 - (ULONG)Last;
	} else {
	    lblbuf  *label_ptr;

	    if( ( label_ptr = search_label( op->opval2 ) ) == NULL )
		return;
	    else {
		shift = label_ptr->shift;
		arg1 = op->opval2 - shift;
	    }
	}

	ptr = make_symbol (strrchr (op->operand, ',') + 1, arg1, shift);
	*ptr++ = ')';
	*ptr++ = '\0';
    }
}


/* x`s̃Ro */
INLINE private void add_extern_colon( char *ptr )
{
    switch( SymbolColonNum ) {
	case 3:
	case 2:			/* -C2 && O`Ȃ '::' */
	    *ptr++ = ':';
	case 1:
	    *ptr++ = ':';
	case 0:
	    *ptr = '\0';
	    break;
    }
}

INLINE private void add_static_colon( char *ptr )
{
    switch( SymbolColonNum ) {
	case 3:
	    *ptr++ = ':';
	case 2:			/* -C2 && !O`Ȃ ':' */
	case 1:
	    *ptr++ = ':';
	case 0:
	    *ptr = '\0';
	    break;
    }
}

/*

  x`so

  input :
    adrs : label address
    mode : label mode

  V{`Ă΁uV{::vA`ȂuLxxxxxx:v
  Ȃǂ̌`ŏo͂(R̐⃉x擪̓IvV̏Ԃŕς).
  V{ɂĂ͑So͂ȂƂ.
  make_symbol()}shift폜ARtǉł.

  V{̕`ɑΉ牘ȂĂ܂...

*/
private void	label_line_out( address adrs , lblmode mode )
{
    char	buff[ 128 ];
    symbol	*symbol_ptr;

    if( isHIDDEN( mode ) )
	return;

    if( Exist_symbol && ( symbol_ptr = symbol_search( adrs ) ) != NULL ) {
	symlist *symlistptr;
	char *ptr;

	strcpy( buff , symbol_ptr->sym );
	ptr = strend( buff );
	if( symbol_ptr->type == 0 ) add_static_colon( ptr );
	else			    add_extern_colon( ptr );

	for( symlistptr = symbol_ptr->next ; symlistptr != NULL ;
	     symlistptr = symlistptr->next )
	{
	    outputa( buff );
	    newline( adrs );

	    strcpy( buff , symlistptr->sym );
	    ptr = strend( buff );
	    if( symbol_ptr->type == 0 ) add_static_colon( ptr );
	    else			add_extern_colon( ptr );
	}
    } else {
	char *ptr = buff;
	*ptr++ = Label_first_char;
	ptr = itox6_without_0supress( ptr , (ULONG)adrs );
	add_static_colon( ptr );
    }
    outputa( buff );
    newline( adrs );
}



/*

  IyhƂẴxo

  input :
    adrs : label address
    mode : label mode

  .endy.dc.l^߂̃Iyh쐬ׂɌĂ΂.
  R͕tȂ.
  +-shtt\.

*/
private void	label_op_out( address adrs )
{
    char	buff[ 128 ];

    make_proper_symbol( buff , adrs );
    outputa( buff );
}



#ifdef	OSKDIS
/*

  vsect xo

  input :
    adrs : label address
    colon : if TRUE , output as beginning-of-line label
    mode : label mode

*/
private void	vlabelout( address adrs , boolean colon , lblmode mode )
{
    char    buff[ 128 ];

    if( isHIDDEN( mode ) )
	return;

    if( colon )
	make_symbol( buff , adrs , 0 );
    else
	make_proper_symbol( buff , adrs );

    outputa( buff );

    if( colon ) {
	if( !option_C )
	    outputca( ':' );
    }		/* 񏉊 vsect ̓x̋Lq͏oȂ */
}
#endif	/* OSKDIS */


/*

  xV{̐

  input :
    buff : buffer of label symbol
    adrs : address

  ł߂V{TAlȂshiftlvZ
  make_symbol()Ăяo.

*/
extern void	make_proper_symbol( char *buff , address adrs )
{
    address	arg1;
    LONG	shift;
    lblbuf	*lblptr;

    if( (LONG)adrs < (LONG)BeginTEXT ) {	/* must be LONG , not ULONG */
	arg1 = BeginTEXT;
	shift = (LONG)adrs - (ULONG)BeginTEXT;
    } else if( (ULONG)adrs > (ULONG)Last ) {
	arg1 = Last;
	shift = (ULONG)adrs - (ULONG)Last;
    } else {
	if( ( lblptr = search_label( adrs ) ) != NULL && ( shift = lblptr->shift ) ) {
	    arg1 = adrs - shift;
	} else {
	    arg1 = adrs;
	    shift = 0;
	}
    }
    make_symbol( buff , arg1 , shift );
}


/*

  V{𐶐

  input :
    ptr : symbol buffer
    adrs : address
    sft : shift count
    colon : colon ̎( -C option )  0 ȂtȂ

  return :
    pointer to generated symbol' tail

  V{e[u΁Aadrs ̓V{ɒuAȂ L?????? `ƂȂ
  sft != 0 Ȃ炻̌ +sft or -sft 

  x`s̐ɂlabel_line_out()g.

*/
extern char	*make_symbol( char *ptr , address adrs , LONG sft )
{
    symbol	*symbol_ptr;

    if( Exist_symbol && ( symbol_ptr = symbol_search( adrs ) ) != NULL ) {
	strcpy( ptr , symbol_ptr->sym );
	ptr = strend( ptr );
    } else {
	*ptr++ = Label_first_char;
	ptr = itox6_without_0supress( ptr , (ULONG)adrs );
    }

    if( sft == 0 )
	return( ptr );

    if( sft > 0 ) {
	*ptr++ = '+';
	return( itox6d( ptr , sft ) );
    } else {
	*ptr++ = '-';
	return( itox6d( ptr , -sft ) );
    }
}


private char	*ctimez( time_t *clock )
{
    char *p;
    p = ctime( clock );
    p[24] = '\0';
    return p;
}


/*

  wb_

  input :
    filename : execute filename
    filedate : execute file' time stamp
    argc	: same to argc given to main()
    argv	: same to argv given to main()

*/
private void
#ifdef	__LIBC__
makeheader (char* filename, time_t filedate, char* argv0, char* comline)
#else
makeheader (char* filename, time_t filedate, int argc, char* argv[])
#endif
{
    char	*envptr;
    time_t	temp = time( NULL );
    char	buffer[256];

    static char	op_include[]	= PSEUDO INCLUDE;
    static char	op_cpu[]	= PSEUDO CPU;
    static char	op_equ[]	= PSEUDO EQU;
    static char	op_xdef[]	= PSEUDO XDEF;
#if 0
    static char	op_fpid[]	= PSEUDO FPID;
#endif

    if (option_U) {
	strupr (op_include);
	strupr (op_cpu);
	strupr (op_equ);
	strupr (op_xdef);
#if 0
	strupr (op_fpid);
#endif
    }

    outputf( "%c=============================================" CR , CommentChar );
    outputf( "%c  Filename %s" CR , CommentChar, filename );
    outputf( "%c  Time Stamp %s" CR , CommentChar , ctimez( &filedate ) );
    outputf( "%c" CR , CommentChar );
#ifndef OSKDIS
    outputf( "%c  Base address %06x" CR , CommentChar, Head.base );
    outputf( "%c  Exec address %06x" CR , CommentChar, Head.exec );
    outputf( "%c  Text size    %06x byte(s)" CR , CommentChar, Head.text );
    outputf( "%c  Data size    %06x byte(s)" CR , CommentChar, Head.data );
    outputf( "%c  Bss  size    %06x byte(s)" CR , CommentChar, Head.bss );
#endif	/* !OSKDIS */
    outputf( "%c  %d Labels" CR , CommentChar, get_Labelnum() );
    outputf( "%c  Code Generate date %s" CR , CommentChar, ctimez( &temp ) );

    if( ( envptr = getenv( DIS_ENVNAME ) ) != NULL )
	outputf( "%c  Environment %s" CR , CommentChar,
		/* option_Q ? "is ignored (-Q option)" : */ envptr );

#ifdef	__LIBC__
    outputf ("%c  Commandline %s %s" CR, CommentChar, argv0, comline);
#else
    outputf ("%c  Commandline ", CommentChar);
    {
	int i;
	for (i = 0; i < argc; i++)
	    outputf( "%s " , argv[ i ] );
    }
    outputf( CR );
#endif

#ifdef	OSKDIS
    outputf( "*          DIS version %s" CR , Version );
    outputf( "*********************************************" CR );

    outputf( "*  Revision    %04x" CR, HeadOSK.sysrev);
    outputf( "*  Module Size %d bytes" CR, HeadOSK.size);
    outputf( "*  Owner       %d.%d" CR, HeadOSK.owner/65536, HeadOSK.owner&0x0FFFF);
    outputf( "*  Name Offset %08x" CR, HeadOSK.name);
    outputf( "*  Permit      %04x" CR, HeadOSK.accs);
    outputf( "*  Type/Lang   %04x" CR, HeadOSK.type);
    outputf( "*  Attribute   %04x" CR, HeadOSK.attr);
    outputf( "*  Edition     %d" CR, HeadOSK.edition);
    outputf( "*  Entry       %08x" CR, HeadOSK.exec);
    outputf( "*  Excpt       %08x" CR, HeadOSK.excpt);

    if ((HeadOSK.type & 0x0F00) == 0x0e00 ||	/* Driver   */
	(HeadOSK.type & 0x0F00) == 0x0b00 ||	/* Trap     */
	(HeadOSK.type & 0x0F00) == 0x0100) {	/* Program  */
	outputf( "*  Memory Size %d" CR, HeadOSK.mem);
    }
    if ((HeadOSK.type & 0x0F00) == 0x0100 ||	/* Program  */
	(HeadOSK.type & 0x0F00) == 0x0b00) {	/* Trap     */
	outputf( "*  Stack Size  %d" CR, HeadOSK.stack);
	outputf( "*  M$IData     %08x" CR, HeadOSK.idata);
	outputf( "*  M$IRefs     %08x" CR, HeadOSK.irefs);
    }
    if ((HeadOSK.type & 0x0F00) == 0x0b00) {	/* Trap     */
	outputf( "*  M$Init      %08x" CR, HeadOSK.init);
	outputf( "*  M$Term      %08x" CR, HeadOSK.term);
    }

    outputf( "*********************************************" CR );
    outputf( "*" CR);
    strcpy(buffer, Top - (ULONG)Head.base + HeadOSK.name);  /* W[ */
    switch (HeadOSK.type & 0x0F00) {
	case 0x0100:	/* Program */
	case 0x0b00:	/* Trap    */
	    outputf("\tpsect\t%s,$%04x,$%04x,", buffer, HeadOSK.type, HeadOSK.attr);
	    outputf("%d,%d,", HeadOSK.edition, HeadOSK.stack);
	    outputf("L%06x", HeadOSK.exec);
	    if (HeadOSK.excpt) outputf(",L%06x", HeadOSK.excpt);
	    break;
	case 0x0200:	/* Subroutine */
	case 0x0c00:	/* System     */
	case 0x0d00:	/* FileMan    */
	case 0x0e00:	/* Driver     */
	    outputf("\tpsect\t%s,$%04x,$%04x,", buffer, HeadOSK.type, HeadOSK.attr);
	    outputf("%d,%d,", HeadOSK.edition, 0);
	    outputf("L%06x", HeadOSK.exec);
	    if (HeadOSK.excpt) outputf(",L%06x", HeadOSK.excpt);
	    break;
    }
#else
    outputf( "%c          DIS version %s" CR , CommentChar, Version );
    outputf( "%c=============================================" CR CR , CommentChar );

    if( ( envptr = getenv( "dis_header" ) ) == NULL ) {
    def:
	outputf ("%s%s" CR, op_include, Doscall_mac_path);
	outputf ("%s%s" CR, op_include, Iocscall_mac_path);
	outputf ("%s%s" CR, op_include, Fefunc_mac_path);
	if (Disasm_SX_Window && Sxcall_mac_path)
	    outputf ("%s%s" CR, op_include, Sxcall_mac_path);
	outputf( CR );
    } else {
	FILE *fp;
	if( ( fp = fopen( envptr , "rt" ) ) == NULL ) {
	    eprintf ("cannot open %s. use default.\n" , envptr);
	    goto def;
	}
	while (fgets (buffer, sizeof buffer, fp)) {
	    char* p = strchr (buffer, '\n');
	    if (p)
		*p = '\0';
	    outputf( "%s" CR , buffer );
	}
	fclose( fp );
    }
#endif	/* OSKDIS */

    /* .cpu ^߂̏o */
    outputf ("%s%s" CR, op_cpu, mputype_numstr (Current_Mputype));

#if 0
    {	/* .fpid ^߂̏o */
	int i;
	for (i = 0; i <= 7; i++)
	    if ((i != 1) && FPUID_table[i*2])
		outputf ("%s" "%d" CR, op_fpid, i);
    }
#endif
    outputf (CR CR);

#ifndef	OSKDIS
    {	/* O`V{̏o */
#ifdef	STATI_CONST_SYM_BUF
	int i , n;
	if ((n = get_constsymbol_num ())) {
	    for (i = 0; i < n; i++) {
		const_symbol* p = get_constsymbol (i);
		char* tab = (strlen (p->sym) < (8-2)) ? "\t" : "";	/* tab-2 */

		outputf ("%s::%s" "%s" "$%x" CR, p->sym, tab, op_equ, p->adrs);
	    }
	    outputf (CR CR);
	}
#else
	char* colon = (SymbolColonNum == 0) ? ""
		    : (SymbolColonNum == 1) ? ":" : "::";
	if (output_symbol_table (op_equ, op_xdef, colon))
	    outputf (CR CR);
    }
#endif	/* STATIC_CONST_SYM_BUF */
#endif	/* !OSKDIS */

}


private char*
mputype_numstr (mputypes m)
{
    if (m & M000) return "68000";
    if (m & M010) return "68010";
    if (m & M020) return "68020";
    if (m & M030) return "68030";
    if (m & M040) return "68040";
 /* if (m & M060) */
		  return "68060";
}


/*

  IyR[h̏o

  input :
    ptr : buffer of opecode ( like "move.l",0 )

*/
private void	output_opecode( char *ptr )
{
    if( option_U ) {
	char	buff[ 20 ];

	strcpy( buff , ptr );
	strupr( buff );
	outputa( buff );
    } else
	outputa( ptr );
}


/* EOF */
