/* $Id: main.c,v 2.76 1995/01/07 11:32:22 ryo Exp $
 *
 *	\[XR[hWFl[^
 *	C[`
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */


#include <ctype.h>	/* tolower */
#include <stdio.h>
#include <stdlib.h>	/* exit */
#include <string.h>	/* memcmp */
#include <time.h>	/* time difftime */

#ifdef unix
#include <conio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#else
#include <io.h>		/* access */
#include <conio.h>	/* getche */
#ifndef MYU_HEADERS
    #include <fcntl.h>	/* open */
    #include <stat.h>	/* open fstat */
#endif
#ifdef	QUICK_YES_NO
    #define __DOS_INLINE__
    #include <sys/dos.h>	/* _dos_getc */
#endif	/* QUICK_YES_NO */
#endif	/* unix */


#include "analyze.h"
#include "disasm.h"
#include "estruct.h"
#include "etc.h"
#include "generate.h"
#include "global.h"
#include "include.h"	/* load_OS_sym() */
#include "label.h"
#include "labelfile.h"
#include "offset.h"
#include "option.h"
#include "symbol.h"
#include "table.h"


USEOPTION	option_g, option_e, option_v, option_d, option_i,
		option_p, option_l, option_p, option_c, option_z,
		option_D, option_T;
USEOPTION	option_overwrite;


extern void	free_load_buffer( void );

#ifndef	OSKDIS
extern const char Date[];
#endif


/* static ֐vg^Cv */
private void	analyze_and_generate (int, char*[]);
private void	check_open_output_file (char*);
private int	check_exist_output_file (char*);
private void	change_filename (char** nameptr, const char* file);


/*#define   DEBUG*/

xheader Head;
#ifdef	OSKDIS
os9header	HeadOSK;
#endif	/* OSKDIS */
ULONG	Top;		/* ۂɃt@ĈAhX	 */
ULONG	Ofst;		/* ۂ̃AhX - zAhX */

/********************************************
  Human68K pi-DOSKDIS j̏ꍇ́A
    BeginTEXT = text section ̐擪
    BeginDATA = data section ̐擪
    BeginBSS  = bss section ̐擪
  OS-9/680x0 pi-DOSKDIS Lj̏ꍇ́A
    BeginTEXT = psect 擪
    BeginDATA =  vsect 擪
    BeginBSS  = vsect 擪
*********************************************/

address BeginTEXT,
	BeginDATA,
	BeginBSS,
	Last;
address Available_text_end;	/* = BeginDATA or BeginBSS */

int Absolute  = NOT_ABSOLUTE;	/* ΔԒn`[h */
				/* NOT_ABSOLUTE, ABSOLUTE_ZFILE, ABSOLUTE_ZOPT */

int String_length_min = 3;  /* ̍ŏ */

int Debug = 0;
int Verbose = 1;
int UndefRegLevel = 1+2+4+8;
int Quiet_mode = 0;
char CommentChar = ';';

mputypes MPU_types = M000;	/* MPU ftHg68000 */
short	MMU_type = 0;		/* MMU ftHgŖT|[g */
short	FPCP_type = 0;		/* FPU ftHgŖT|[g */
short	Emulate_mode = 3;	/* bit0=1:fpsp bit1=1:isp emulation߂F */

address Base;		/* [hAhX */
address Exec;		/* sJnAhX */
boolean Exist_symbol;	/* V{e[ȗ݃tO */

#ifndef	OSKDIS
char	FileType;	/* t@C`(0,'x','r','z') */
#endif

char*	Filename_in;
char*	Filename_out;
char*	Labelfilename_in;
char*	Labelfilename_out;
char*	Tablefilename;



extern void print_title( void )
{
    static char flag = 1;

    if( flag ) {
	flag = 0;
#ifdef	OSKDIS
	eprintf( "\[XR[hWFl[^ for OS-9/68000 version %s\n"
		 "Copyright (C) 1989-1992 K.Abe\n"
		 "OS-9/68000 version by TEMPLE, 1994\n" , Version );
#else
	eprintf ("\[XR[hWFl[^ for X680x0 version %s\n"
		 "Copyright (C)1989-1992 K.Abe, 1994-1997 R.ShimiZu, "
				"%s Tachibana Eriko.\n", Version, Date);
#endif	/* OSKOSK */
    }
}


typedef struct {
    short bit;
    char* name;
} target_table;

private void
print_target (char* str, int bits, const target_table* tbl, int size)
{
    if (bits) {
	int f = '\0';
	eprintf (str);
	do {
	    if (bits & tbl->bit) {
		if (f)
		    eputc (f);
		eprintf (tbl->name);
		f = ',';
	    }
	    tbl++;
	} while (--size);
	eputc ('\n');
    }
}


/*

  t@Cǂݍ݁Awb_ϐ Head ɃZbg
  t@C̓t Filedate ɃZbg
  ǂݍ񂾐擪AhXԂ

*/
static time_t	Filedate;

private INLINE address
loadfile (char* filename)
{
    int		handle;
    address	top;
    ULONG	bytes;
    struct stat	statbuf;

#ifdef	OSK
    if ((handle = open (filename, S_IREAD)) == -1)
#else
    if ((handle = open (filename, O_BINARY|O_RDONLY, S_IRUSR)) == -1)
#endif	/* OSK */
	err ("%s I[vo܂.\n", filename);

    if( fstat( handle , &statbuf ) < 0 )
	err ("fstat failed.\n");
    Filedate = statbuf.st_mtime;

#ifdef	OSKDIS
    if( option_z ) {
	Head.base = Base;
	Head.exec = Exec;
	Head.text = statbuf.st_size;
	Head.data = 0;
	Head.bss = 0;
	Head.symbol = 0;
	Head.bindinfo = 0;
    } else {
	if (read (handle, (char *)&HeadOSK, sizeof (HeadOSK)) != sizeof (HeadOSK))
	    goto os9head_error;
	if (HeadOSK.head != 0x4afc) {
	    eprintf( "ID=%04X\n", HeadOSK.head );
os9head_error:
	    close(handle);
	    err ("OS-9/680x0 ̃W[ł͂܂.\n");
	}
	switch (HeadOSK.type & 0x0f00) {
	    case 0x0100:	/* Program */
		Head.base = 0x0048;
		Head.bss = HeadOSK.mem;
		break;
	    case 0x0b00:	/* Trap */
		Head.base = 0x0048;
		Head.bss = HeadOSK.mem;
		break;
	    case 0x0200:	/* Subroutine */
	    case 0x0c00:	/* System     */
	    case 0x0d00:	/* FileMan    */
	    case 0x0e00:	/* Driver     */
		Head.base = 0x003c;
		Head.bss = HeadOSK.mem;
		break;
	    default:
		close(handle);
		err ("̃W[^Cv̓T|[gĂ܂.\n");
	}
	lseek(handle, Head.base, 0);
	Head.exec = HeadOSK.exec;
	Head.text = statbuf.st_size - (ULONG)(Head.base);
	Head.data = 0;
	Head.symbol = 0;
	Head.bindinfo = 0;
    }
#else
    if (FileType == 0) {
	char*	ext = strrchr (filename, '.');

	/* R `͊gqŔʂ */
	if (ext && strcmpi (ext, ".r") == 0)
	    FileType = 'r';
	else {
	    char buf[2];

	    /* 擪 2 oCgǂݍ */
	    read (handle, buf, 2);
	    lseek (handle, 0, SEEK_SET);

	    /* t@C`𔻕ʂ */
	    if (buf[0] == (char)'H' && buf[1] == (char)'U')
		FileType = 'x';
	    else if (buf[0] == (char)0x60 && buf[1] == (char)0x1a)
		FileType = 'z';
	    else
		goto filetype_error;
	}
    }

    if (option_z || FileType == (char)'r') {
	Head.base = Base;
	Head.exec = Exec;
	Head.text = statbuf.st_size;
	Head.data = 0;
	Head.bss = 0;
	Head.symbol = 0;
	Head.bindinfo = 0;
    } else if (FileType == (char)'z') {
	struct {
	    UWORD   header;
	    ULONG   text;
	    ULONG   data;
	    ULONG   bss;
	    char    reserve[8];
	    address base;
	    UWORD   pudding;
	} zhead;

	if (read (handle, (char *)&zhead, sizeof (zhead)) != sizeof (zhead))
	    goto filetype_error;
	Head.base = zhead.base;
	Head.exec = zhead.base;
	Head.text = zhead.text;
	Head.data = zhead.data;
	Head.bss = zhead.bss;
	Head.symbol = 0;
	Head.bindinfo = 0;
	Absolute = ABSOLUTE_ZFILE;
    } else {		/* if (FileType == (char)'x') */
	if (read (handle, (char *)&Head, sizeof (Head)) != sizeof (Head)) {
filetype_error:
	    close (handle);
	    err ("̂悤ȃt@C͎舵Ă܂.\n");
	}
    }
#endif	/* OSKDIS */

    bytes = Head.text + Head.data + Head.offset + Head.symbol;
    top = (address) Malloc (bytes + 16);

    if (read (handle, (char*)top, bytes) != bytes) {
	close (handle);
	err ("t@CTCYُł.\n");
    }

    close (handle);
    return top;
}



int main( int argc , char *argv[] )
{
    time_t start_time = time (NULL);

#ifdef	OSK
    setbuf( stderr, 0 );	/* stderr ̓obt@OȂ */
    setbuf( stdout, 0 );	/* stdout ̓obt@OȂ */
#endif	/* OSK */
    setbuf( stderr , NULL );

    analyze_args( argc , argv );
    print_title();

    eprintf ("%s ǂݍ݂܂.\n", Filename_in);

    /* AhX֌W̑ϐ */
    Top = (ULONG)loadfile (Filename_in);
    Ofst = Top - (ULONG)Head.base;
    BeginTEXT = Head.base;
#ifdef	OSKDIS
    BeginBSS  = BeginTEXT + Head.text;
    BeginDATA = BeginBSS  + Head.bss;
    Last      = BeginDATA + Head.data;
/*  Available_text_end = ( option_D ? BeginBSS : BeginDATA ); */
    Available_text_end = BeginBSS;

#else
    BeginDATA = BeginTEXT + Head.text;
    BeginBSS  = BeginDATA + Head.data;
    Last      = BeginBSS  + Head.bss;
    Available_text_end = ( option_D ? BeginBSS : BeginDATA );

    if( Head.bindinfo ) {
	eprintf( "̃t@C bind Ă܂.\n"
		 "unbind R}hœWJĂ\[XWFl[gĉ.\n" );
	return 1;
    }
#endif	/* OSKDIS */

    load_OS_sym();
    init_labelbuf();
    init_symtable();


    /* Ώ MPU/MMU/FPU ̕\ */
    {
	static const target_table mpu_table[] = {
	    { M000, "68000" },
	    { M010, "68010" },
	    { M020, "68020" },
	    { M030, "68030" },
	    { M040, "68040" },
	    { M060, "68060" },
	    { MISP, "060ISP" }
	};

	static const target_table mmu_table[] = {
	    { MMU851, "68851" },
	    { MMU030, "68030" },
	    { MMU040, "68040" },
	    { MMU060, "68060" }
	};

	static const target_table fpu_table[] = {
	    { F881, "68881" },
	    { F882, "68882" },
	    { F040, "68040" },
	    { F4SP, "040FPSP" },
	    { F060, "68060" },
	    { F6SP, "060FPSP" }
	};

	print_target ("Target MPU: ", MPU_types,
		mpu_table, (sizeof mpu_table / sizeof mpu_table[0]));

	print_target ("Target MMU: ", MMU_type,
		mmu_table, (sizeof mmu_table / sizeof mmu_table[0]));

	print_target ("Target FPU: ", FPCP_type,
		fpu_table, (sizeof fpu_table / sizeof fpu_table[0]));
    }


#ifndef OSKDIS
    eprintf( "P[gWJ܂.\n" );
    make_relocate_table();
#endif	/* !OSKDIS */


    while (check_exist_output_file (Filename_out))
	change_filename (&Filename_out, "source");

    if (option_e)
	while (check_exist_output_file (Labelfilename_out))
	    change_filename (&Labelfilename_out, "label");

    check_open_output_file (Filename_out);

    if( option_g ) {
	eprintf( "xt@Cǂݍݒł.\n" );
	read_labelfile( Labelfilename_in );
    }
    if( option_e )
	check_open_output_file( Labelfilename_out );
    if( option_T ) {
	eprintf( "e[uLqt@Cǂݍݒł.\n" );
	read_tablefile( Tablefilename );
    }

#ifndef OSKDIS
 /* if( !option_g ) */ {
	if( Head.symbol ) {
	    eprintf( "V{e[uWJ܂.\n" );
	    make_symtable();
	} else
	    eprintf( "V{e[u͎cOȂ瑶݂܂.\n" );
    }
#endif	/* OSKDIS */

    Exist_symbol = is_exist_symbol();

    analyze_and_generate( argc , argv );

    eprintf( "\nI܂.\n" );
    free_labelbuf();
    free_relocate_buffer();
    free_symbuf();
    free_load_buffer();

    {
	time_t finish_time = time (NULL);
	eprintf ("v: %db\n", (int) difftime (finish_time, start_time));
    }

    return 0;
}



/*

  foCXhCȍ

*/
#ifndef OSKDIS
private void	analyze_device( void )
{
    ULONG   ad = 0;

    Reason_verbose = ( Verbose >= 1 ? TRUE : FALSE );

    do {
	regist_label (Head.base + ad       , DATLABEL | LONGSIZE | FORCE);
	regist_label (Head.base + ad + 4   , DATLABEL | WORDSIZE | FORCE | HIDDEN);
#if 0
	regist_label (Head.base + ad + 6   , DATLABEL | LONGSIZE | FORCE);
	regist_label (Head.base + ad + 0xa , DATLABEL | LONGSIZE | FORCE);
#endif
	regist_label (Head.base + ad + 0xe , DATLABEL | STRING | FORCE | HIDDEN);
	regist_label (Head.base + ad + 0x16, DATLABEL | UNKNOWN);
	analyze( *(address*)( Ofst + ad + 6   ) , ANALYZE_IGNOREFAULT );
	analyze( *(address*)( Ofst + ad + 0xa ) , ANALYZE_IGNOREFAULT );
	ad = *(ULONG*)( ad + Ofst );
    } while( ((ad & 1) == 0) /* && (ad != 0xffffffff) */
	   && (ad < (ULONG)BeginBSS) );		/* SCSIDRV.SYS ΍ */
}
#endif	/* OSKDIS */


/*

  ͂Đ

*/
private void	analyze_and_generate( int argc , char *argv[] )
{
    if( option_v ) {
	eprintf( "tAZuXgo͂܂.\n" );
	disasmlist (Filename_in, Filename_out, Filedate);
	return;
    }

    Disasm_String = FALSE;  /* ͒̓j[jbN͕sv */
    if( !option_g ) {

#ifdef	OSKDIS
	switch(HeadOSK.type & 0x0F00) {
	    case 0x0100:	/* Program */
	    case 0x0b00:	/* Trap */
		eprintf( "\nf[^̈͒ł.");
		analyze_idata();	/* f[^ItZbg   */
		analyze_irefs();	/* f[^Qƃe[u */
		eputc( '\n' );
	    default:
		break;
	}
	regist_label( Head.base + Head.text + Head.data + Head.bss, DATLABEL | UNKNOWN );
#endif	/* OSKDIS */

	eprintf( "vÖ͒ł." );
	/* ZNṼGgAhXe[uɓo^ */
	regist_label (BeginTEXT, DATLABEL | UNKNOWN);
	regist_label (BeginDATA, DATLABEL | UNKNOWN);
	regist_label (BeginBSS , DATLABEL | UNKNOWN);
#if 0
	regist_label (Last,	 DATLABEL | UNKNOWN);
#else	/* Ō̃x unregist s̑Ώ */
	regist_label (Last,	 DATLABEL | UNKNOWN | SYMLABEL);
#endif
	Reason_verbose = (Verbose >= 1) ? TRUE : FALSE;

#ifdef	OSKDIS
	switch(HeadOSK.type & 0x0F00) {
	    case 0x0b00:	/* Trap */
		regist_label( HeadOSK.init, PROLABEL | WORDSIZE | FORCE );
		regist_label( HeadOSK.term, PROLABEL | WORDSIZE | FORCE );
		z_table(0x000048);
	    case 0x0100:	/* Program */
#if 1	/* fobÖׂ̃R[h */
		regist_label( HeadOSK.idata, DATLABEL | LONGSIZE | FORCE );
		regist_label( HeadOSK.irefs, DATLABEL | WORDSIZE | FORCE );
#endif
		break;
	    case 0x0200:	/* Subroutine */
	    case 0x0c00:	/* System */
		break;
	    case 0x0d00:	/* FileMan */
		regist_label( HeadOSK.exec + 0 , DATLABEL | WORDSIZE | FORCE );
		relative_table(HeadOSK.exec);
		break;
	    case 0x0e00:
		regist_label( HeadOSK.exec + 0 , DATLABEL | WORDSIZE | FORCE );
		w_table(HeadOSK.exec);
		break;
	}
	regist_label( HeadOSK.excpt, PROLABEL | WORDSIZE | FORCE );
	regist_label( HeadOSK.name, DATLABEL | STRING | FORCE );
#if 1
	regist_label( HeadOSK.size-4, DATLABEL | BYTESIZE | FORCE );	/* CRC */
#endif
	analyze( Head.exec , ANALYZE_IGNOREFAULT );

#else	/* !OSKDIS */
	if( option_d ) {
	    analyze_device();
	    if( Head.exec != Head.base )
	    analyze( Head.exec , option_i ? ANALYZE_IGNOREFAULT : ANALYZE_NORMAL );
	} else
	    analyze( Head.exec , ANALYZE_IGNOREFAULT );
#endif	/* OSKDIS */
    }

    Reason_verbose = ( Verbose == 2 ? TRUE : FALSE );
    eprintf( "\nf[^̈͒ł." );
    analyze_data();

#if 0
    if (!option_g) {
	eprintf ("\nAhXe[u{Ă܂.");
	search_adrs_table ();
    }
#endif

    if( !option_p )
	do {
	    eprintf( "\nf[^̈̒vÖ{Ă܂(1)." );
	} while( research_data() && !option_l );

    if( String_length_min != 0 )
	do {
	    eprintf( "\n{Ă܂." );
	    if( !search_string( String_length_min ) || option_p )
		break;
	    eprintf( "\nf[^̈̒vÖ{Ă܂(2)." );
	    if( !research_data() )
		break;
	    do {
		eprintf( "\nf[^̈̒vÖ{Ă܂." );
	    } while( research_data() && !option_l );
	} while( !option_l );

    if( !option_c ) {
	eprintf( "\nx`FbN." );
	search_operand_label();
    }

    if( option_e ) {
	eprintf( "xt@C쐬ł.\n" );
	make_labelfile (Filename_in, Labelfilename_out);
    }

    eprintf( "\[X쐬ł." );
    generate (Filename_in, Filename_out, Filedate , argc , argv );
}


/*

  n

*/
extern void free_load_buffer( void )
{
    Mfree( (void*)Top );
}



/*

  o̓t@C̑݃`FbN

  Ԓl: 0 = o͉\
	1 = t@CύX

*/
private int
check_exist_output_file (char *filename)
{
    FILE *fp;

    /* --overwrite w莞͖ɏ㏑. */
    if (option_overwrite)
	return 0;

    /* Wo͂ɏo͂Ȃ猟sv. */
    if (strcmp ("-", filename) == 0)
	return 0;

    /* t@C݂ȂOK. */
    if ((fp = fopen (filename, "r")) == NULL)
	return 0;

    /* [foCXւ̏o͂ȂOK. */
    if (isatty (fileno (fp))) {
	fclose (fp);
	return 0;
    }

    /* łȂ΃L[. */
    fclose (fp);

#ifdef	QUICK_YES_NO	/* version 2.79 ݊ */
    {
	int key;
	eprintf ("%s ɑ݂܂.\n"
		 "Over Write ( Y or N )? ", filename);
	do {
	    key = _dos_getc ();
	    eprintf ("%c", key);
	    key = tolower (key);
	} while (key != 'y' && key != 'n');
	eprintf ("\n");
	if (key == 'y')
	    return 0;
    }
#else			/* S̈ "yes" ͂. */
    {
	char buf[256];
	eprintf ("%s ɑ݂܂.\n"
		 "㏑܂H(Yes/No/Rename): ", filename);

	if (fgets (buf, sizeof buf, stdin)) {
	    /* y, yes Ȃ㏑ */
	    if (strcmpi (buf, "y\n") == 0 || strcmpi (buf, "yes\n") == 0)
		return 0;
	    /* r, rename Ȃt@CύX */
	    if (strcmpi (buf, "r\n") == 0 || strcmpi (buf, "rename\n") == 0)
		return 1;
	}
    }
#endif	/* QUICK_YES_NO */

    /* ㏑ȂȂvOI. */
    exit (1);
}


/*

  o̓t@CύX.

*/
private void
change_filename (char** nameptr, const char* file)
{
    char buf[PATH_MAX + 1];
    int len;

    eprintf ("Input %s filename:", file);
 /* fflush (stderr); */
    if (fgets (buf, sizeof buf, stdin) && (len = strlen (buf)) > 1) {
	buf[len - 1] = '\0';
	*nameptr = strcpy (Malloc (len), buf);
	return;
    }
    exit (1);
}


/*

  o̓t@Cɏ߂ǂ̃`FbN

*/
private void	check_open_output_file( char *filename )
{
    int fd;

    if( !strcmp( "-" , filename ) ) return;

#ifdef	OSK
    if( ( fd = open( filename , S_IREAD ) ) < 0 ) return;
#else
    if( ( fd = open( filename , O_RDONLY ) ) < 0 ) return;
#endif	/* OSK */

    if( isatty( fd ) ) {
	close( fd );
	return;
    }
    close( fd );
    if( access( filename , R_OK | W_OK ) < 0 )
	err ("%s ɃANZXł܂(!)\n", filename);
}

/* EOF */
